/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact address:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.*;

import javax.swing.*;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

import de.uni_paderborn.fujaba.app.FrameMain;
import de.uni_paderborn.fujaba.app.messages.WarningMessages;
import de.uni_paderborn.fujaba.asg.ASGDiagram;
import de.uni_paderborn.fujaba.gui.comp.FujabaDialog;
import de.uni_paderborn.fujaba.gui.comp.JglListModel;
import de.uni_paderborn.fujaba.uml.*;


/**
 * No comment provided by developer, please add a comment to improve documentation.
 *
 * @author    $Author: trinet $
 * @version   $Revision: 1.29 $
 */
public class EditClassDiagDialog extends FujabaDialog
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private JTextField diagName = new JTextField();
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   JList listDisplay = new JList();
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   JList listAvailable = new JList();
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private JButton buttonAdd = new JButton ("<--");
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private JButton buttonDelete = new JButton ("-->");
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private JButton buttonAddContext = new JButton ("<--");
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private JButton buttonDeleteContext = new JButton ("-->");

   /*
    *  Data-Stuff
    */
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private UMLClassDiagram classDiag = null;

   /*
    *  help-things
    */
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private TreeMap display = new TreeMap();
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private TreeMap available = new TreeMap();

   // ######################################################################

   /**
    * use this constructor, if the user want to edit a selected class
    *
    * @param frame  No description provided
    * @param diag   No description provided
    */
   public EditClassDiagDialog (JFrame frame, UMLClassDiagram diag)
   {
      super (frame, "Classdiagram Editor", true);
      this.guiInit();
      this.classDiag = diag;
      this.unparse();
   }


   /**
    * use this constructor, if the user want to edit a new class
    *
    * @param frame  No description provided
    */
   public EditClassDiagDialog (JFrame frame)
   {
      super (frame, "Classdiagram Editor", true);
      this.guiInit();
      this.classDiag = null;
      this.unparse();
   }

   // ######################################################################

   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private final void guiInit()
   {
      JPanel panel = new JPanel();
      panel.setLayout (new BorderLayout());
      panel.add (this.guiNamePanel(), BorderLayout.NORTH);
      panel.add (this.guiWorkPanel(), BorderLayout.CENTER);
      panel.add (this.guiPanelOkCancelHelp(), BorderLayout.SOUTH);

      this.getContentPane().add (panel);
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   private final JPanel guiNamePanel()
   {
      JPanel panel = new JPanel();

      //----- set gridbaglayout to the panel
      GridBagLayout gridbag = new GridBagLayout();
      GridBagConstraints constraints = new GridBagConstraints();

      constraints.gridheight = 1;
      constraints.insets = new Insets (5, 5, 5, 5);
      constraints.anchor = GridBagConstraints.WEST;
      constraints.fill = GridBagConstraints.HORIZONTAL;
      constraints.weightx = 1.0;
      constraints.weighty = 0.0;

      panel.setLayout (gridbag);
      panel.setBorder (new TitledBorder (new EtchedBorder(), "Diagram Name"));
      panel.add (diagName, constraints);

      return panel;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   private final JPanel guiWorkPanel()
   {
      JPanel panel = new JPanel();
      JPanel tmpPanel;

      //----- set gridbaglayout to the panel
      GridBagLayout gridbag = new GridBagLayout();
      GridBagConstraints constraints = new GridBagConstraints();
      panel.setLayout (gridbag);

      //----- some pre-settings to the constraints
      constraints.gridwidth = 1;
      constraints.gridheight = 1;
      constraints.fill = GridBagConstraints.BOTH;
      constraints.ipadx = 5;
      constraints.ipady = 5;
      constraints.insets = new Insets (5, 0, 5, 5);
      constraints.anchor = GridBagConstraints.NORTHWEST;
      constraints.weightx = 1.0;
      constraints.weighty = 1.0;

      panel.add (guiLeftSide(), constraints);

      constraints.fill = GridBagConstraints.HORIZONTAL;
      constraints.anchor = GridBagConstraints.CENTER;
      constraints.insets = new Insets (5, 5, 5, 5);
      constraints.weightx = 0.0;
      constraints.weighty = 0.0;
      tmpPanel = this.guiMiddle();
      gridbag.setConstraints (tmpPanel, constraints);
      panel.add (tmpPanel);

      constraints.anchor = GridBagConstraints.NORTHWEST;
      constraints.gridwidth = GridBagConstraints.REMAINDER;
      constraints.fill = GridBagConstraints.BOTH;
      constraints.insets = new Insets (5, 5, 5, 0);
      constraints.weightx = 1.0;
      constraints.weighty = 1.0;
      panel.add (guiRightSide(), constraints);

      return panel;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   private final JPanel guiLeftSide()
   {
      //----- add all gui-stuff to the panel
      JPanel leftPanel = new JPanel (new BorderLayout());
      JScrollPane sPane = new JScrollPane (this.listDisplay);

      // add and delete context buttons
      leftPanel.setBorder (new TitledBorder (new EtchedBorder(), "classes of diagram"));
      leftPanel.add (sPane, BorderLayout.CENTER);
      leftPanel.setPreferredSize (new Dimension (275, 425));

      return leftPanel;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   private final JPanel guiRightSide()
   {
      //----- add all gui-stuff to the panel
      JPanel rightPanel = new JPanel (new BorderLayout());

      JScrollPane sPane = new JScrollPane (this.listAvailable);

      // add and delete context buttons
      rightPanel.setBorder (new TitledBorder (new EtchedBorder(), "available classes"));
      rightPanel.add (sPane, BorderLayout.CENTER);
      rightPanel.setPreferredSize (new Dimension (275, 425));

      return rightPanel;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @return   No description provided
    */
   private final JPanel guiMiddle()
   {
      GridLayout grid = new GridLayout (2, 1);
      JPanel contextPanel = new JPanel();

      // add and delete context buttons
      contextPanel.setLayout (grid);
      contextPanel.setBorder (new TitledBorder (new EtchedBorder(), "Context"));
      contextPanel.add (buttonAddContext);
      contextPanel.add (buttonDeleteContext);

      //----- set gridbaglayout to the panel
      GridBagLayout gridbag = new GridBagLayout();
      GridBagConstraints constraints = new GridBagConstraints();
      //----- some pre-settings to the constraints
      constraints.gridwidth = GridBagConstraints.REMAINDER;
      constraints.gridheight = 1;
      constraints.fill = GridBagConstraints.HORIZONTAL;
      constraints.anchor = GridBagConstraints.CENTER;
      constraints.weightx = 0.0;
      constraints.weighty = 0.0;
      constraints.insets = new Insets (0, 5, 0, 5);

      // action listeners for context buttons
      this.buttonAddContext.addActionListener (new ButtonAddContextActionListener());
      this.buttonDeleteContext.addActionListener (new ButtonDeleteContextActionListener());

      JPanel panel = new JPanel();

      panel.setLayout (gridbag);
      this.buttonAdd.addActionListener (new ButtonAddActionListener());
      panel.add (this.buttonAdd, constraints);
      this.buttonDelete.addActionListener (new ButtonDeleteActionListener());
      panel.add (this.buttonDelete, constraints);

      constraints.insets = new Insets (10, 0, 0, 0);
      panel.add (contextPanel, constraints);
      return panel;
   }

   // ######################################################################

   /**
    * UML-AST to dialog
    */
   public void unparse()
   {
      //this.unparsePackageTree();
      if (classDiag != null)
      {
         diagName.setText (classDiag.getName());
      } // end of if ()

      this.fillDisplay();
      this.fillAvailable (UMLProject.get().getRootPackage());
      this.updateGuiList();
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public void updateGuiList()
   {
      JglListModel tmp = new JglListModel (this.display);
      tmp.setUseKey (true);
      this.listDisplay.setModel (tmp);
      this.listDisplay.setSelectionMode (ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

      tmp = new JglListModel (this.available);
      tmp.setUseKey (true);
      this.listAvailable.setModel (tmp);
      this.listAvailable.setSelectionMode (ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public void fillDisplay()
   {
      Iterator iter = classDiag.iteratorOfElements();

      while (iter.hasNext())
      {
         Object item = iter.next();
         if (item instanceof UMLClass)
         {
            this.display.put ( ((UMLClass) item).getFullClassName(), item);
         }
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param pack  No description provided
    */
   public void fillAvailable (UMLPackage pack)
   {
      Object obj;
      Enumeration enumeration = pack.elementsOfAllChildren();
      String key;
      while (enumeration.hasMoreElements())
      {
         obj = enumeration.nextElement();
         if (obj instanceof UMLPackage)
         {
            this.fillAvailable ((UMLPackage) obj);
         }
         else if (obj instanceof UMLClass)
         {
            key =  ((UMLClass) obj).getFullClassName();
            if (this.display.get (key) == null)
            {
               this.available.put (key, obj);
            }
         }
      }
   }

   // ######################################################################

   /**
    * dialog to UML-AST
    */
   public void parse()
   {
      boolean found = false;
      String newName = diagName.getText();

      if (newName == null ||
         newName.trim().equals (""))
      {
         WarningMessages.warnUnnamedDiagram (FrameMain.get(), "class");
         found = true;
      }

      Iterator iter = UMLProject.get().iteratorOfDiags();
      while (!found && iter.hasNext())
      {
         ASGDiagram diagram = (ASGDiagram) iter.next();
         if ( (diagram instanceof UMLClassDiagram) &&
             (diagram != this.classDiag) &&
             (diagram.getName().equals (newName)))
         {
            WarningMessages.warnDoubleIdentifiedDiagram (FrameMain.get(), "class", newName);
            found = true;
         }
      }

      if (!found)
      {
         this.classDiag.setName (diagName.getText());
      } // end of if ()

      //----- remove classes from diagram
      iter = this.classDiag.iteratorOfElements();
      while (iter.hasNext())
      {
         Object obj = iter.next();
         if (obj instanceof UMLClass)
         {
            UMLClass clazz = (UMLClass) obj;

            //remove the comment associated with clazz
            UMLCommentary comment = clazz.getComment();
            if (comment != null)
            {
               this.classDiag.removeFromElements (comment);
               //the dashed line between comment and class will not be removed
               //but if someone is familiar with fsa stuff ...
            }

            // remove generalizations
            Iterator genIter = clazz.iteratorOfRevSubclass();
            while (genIter.hasNext())
            {
               UMLGeneralization generalization = (UMLGeneralization) genIter.next();
               classDiag.removeFromElements (generalization);
            }
            genIter = clazz.iteratorOfRevSuperclass();
            while (genIter.hasNext())
            {
               UMLGeneralization generalization = (UMLGeneralization) genIter.next();
               classDiag.removeFromElements (generalization);
            }
            // remove assocs
            Iterator rolesIter = clazz.iteratorOfRoles();
            while (rolesIter.hasNext())
            {
               UMLRole role = (UMLRole) rolesIter.next();
               classDiag.removeFromElements (role.getAssoc());
            }

            String key =  ((UMLClass) obj).getFullClassName();
            if (this.display.get (key) == null)
            {
               this.classDiag.removeFromElements (clazz);
            }
         }
      }

      //----- add classes to diagram
      iter = this.display.values().iterator();
      while (iter.hasNext())
      {
         UMLClass clazz = (UMLClass) iter.next();
         this.classDiag.addToElements (clazz);

         //add the classes comment
         UMLCommentary comment = clazz.getComment();
         if (comment != null)
         {
            this.classDiag.addToElements (comment);
         }

         Enumeration enumGen;
         UMLGeneralization gen;
         enumGen = clazz.elementsOfRevSubclass();
         while (enumGen.hasMoreElements())
         {
            gen = (UMLGeneralization) enumGen.nextElement();
            if (this.classDiag.hasInElements (gen.getSuperclass()))
            {
               this.classDiag.addToElements (gen);
            }
         }

         enumGen = clazz.elementsOfRevSuperclass();
         while (enumGen.hasMoreElements())
         {
            gen = (UMLGeneralization) enumGen.nextElement();
            if (this.classDiag.hasInElements (gen.getSubclass()))
            {
               this.classDiag.addToElements (gen);
            }
         }

         Iterator roleIter = clazz.iteratorOfRoles();
         while (roleIter.hasNext())
         {
            UMLRole role = (UMLRole) roleIter.next();
            UMLAssoc assoc = role.getAssoc();

            if (role.getPartnerRole() != null)
            {
               UMLClass partner = role.getPartnerRole().getTarget();
               if (this.classDiag.hasInElements (partner))
               {
                  this.classDiag.addToElements (assoc);
               }
            } // end of if ()

         }
      }
      FrameMain.get().createNewTreeItems();

      UMLProject.get().refreshDisplay();
   }

   // ######################################################################

   /**
    * Access method for an one to n association.
    *
    * @param add  The object added.
    * @param con  The object added.
    */
   void addDisplay (Object[] add, boolean con)
   {
      this.addRemoveList (this.display, this.available, add, con);
   }


   /**
    * Access method for an one to n association.
    *
    * @param add  The object added.
    * @param con  The object added.
    */
   void addAvailable (Object[] add, boolean con)
   {
      this.addRemoveList (this.available, this.display, add, con);
   }


   /**
    * Access method for an one to n association.
    *
    * @param addTo    The object added.
    * @param remFrom  The object added.
    * @param obj      The object added.
    * @param con      The object added.
    */
   private void addRemoveList (TreeMap addTo, TreeMap remFrom,
                               Object[] obj, boolean con)
   {
      if (obj != null)
      {
         if (con == true)
         {
            Object value;
            for (int i = 0; i < obj.length; i++)
            {
               value = remFrom.get (obj[i]);
               if (value instanceof UMLClass)
               {
                  this.addRemoveList (addTo, remFrom,
                     this.getContext ((UMLClass) value));
               }
            }
         }
         this.addRemoveList (addTo, remFrom, obj);
         updateGuiList();
      }
   }


   /**
    * Get the context attribute of the EditClassDiagDialog object
    *
    * @param clazz  No description provided
    * @return       The context value
    */
   private Object[] getContext (UMLClass clazz)
   {
      LinkedList context = new LinkedList();
      Enumeration enumeration;
      UMLGeneralization gen;

      //----- add parents
      enumeration = clazz.elementsOfRevSubclass();
      while (enumeration.hasMoreElements())
      {
         gen = (UMLGeneralization) enumeration.nextElement();
         context.add (gen.getSuperclass().getFullClassName());
      }

      //----- add children
      enumeration = clazz.elementsOfRevSuperclass();
      while (enumeration.hasMoreElements())
      {
         gen = (UMLGeneralization) enumeration.nextElement();
         context.add (gen.getSubclass().getFullClassName());
      }

      //----- add all class of the assocs
      Iterator iter = clazz.iteratorOfRoles();
      while (iter.hasNext())
      {
         UMLRole role = (UMLRole) iter.next();
         UMLRole partner = role.getPartnerRole();
         context.add (partner.getTarget().getFullClassName());
      }

      return context.toArray();
   }


   /**
    * Access method for an one to n association.
    *
    * @param addTo    The object added.
    * @param remFrom  The object added.
    * @param obj      The object added.
    */
   private void addRemoveList (TreeMap addTo, TreeMap remFrom,
                               Object[] obj)
   {
      if (obj != null)
      {
         Object value;
         for (int i = 0; i < obj.length; i++)
         {
            value = remFrom.get (obj[i]);
            if (value instanceof UMLClass)
            {
               remFrom.remove (obj[i]);
               addTo.put (obj[i], value);
            }
         }
      }
   }

   // ######################################################################
   // ----- some action classes
   // ######################################################################

   /*
    *  action-stuff
    */
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @author    $Author: trinet $
    * @version   $Revision: 1.29 $
    */
   class ButtonAddActionListener implements java.awt.event.ActionListener
   {
      /**
       * No comment provided by developer, please add a comment to improve documentation.
       *
       * @param e  No description provided
       */
      public void actionPerformed (ActionEvent e)
      {
         addDisplay (listAvailable.getSelectedValues(), false);
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @author    $Author: trinet $
    * @version   $Revision: 1.29 $
    */
   class ButtonAddContextActionListener implements java.awt.event.ActionListener
   {
      /**
       * No comment provided by developer, please add a comment to improve documentation.
       *
       * @param e  No description provided
       */
      public void actionPerformed (ActionEvent e)
      {
         addDisplay (listAvailable.getSelectedValues(), true);
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @author    $Author: trinet $
    * @version   $Revision: 1.29 $
    */
   class ButtonDeleteActionListener implements java.awt.event.ActionListener
   {
      /**
       * No comment provided by developer, please add a comment to improve documentation.
       *
       * @param e  No description provided
       */
      public void actionPerformed (ActionEvent e)
      {
         addAvailable (listDisplay.getSelectedValues(), false);
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @author    $Author: trinet $
    * @version   $Revision: 1.29 $
    */
   class ButtonDeleteContextActionListener implements java.awt.event.ActionListener
   {
      /**
       * No comment provided by developer, please add a comment to improve documentation.
       *
       * @param e  No description provided
       */
      public void actionPerformed (ActionEvent e)
      {
         addAvailable (listDisplay.getSelectedValues(), true);
      }
   }

}

/*
 * $Log: EditClassDiagDialog.java,v $
 * Revision 1.29  2004/11/08 19:16:14  trinet
 * changed saving of FSAProperties, added String support for Maps in BasicIncrement, some cleanup
 *
 */
