package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLArray;

public class ArrayMultiReferenceEngine
extends GFRNEngine
{
   private  ArrayMultiReferenceEngine()
   {
   }

   private static ArrayMultiReferenceEngine theArrayMultiReferenceEngine;

   public static ArrayMultiReferenceEngine get()
   {
      if (theArrayMultiReferenceEngine == null)
      {
         theArrayMultiReferenceEngine = new ArrayMultiReferenceEngine ();
      }
      return theArrayMultiReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ArrayMultiReferenceAnnotation arrayMultiReference = null ;
      Iterator fujaba__IterUMLArray5RevAttrTypeUMLAttr4 = null ;
      Iterator fujaba__IterUMLAttr4AnnotationsArrayMultiReference = null ;
      Iterator fujaba__IterUMLClass3AnnotationsArrayMultiReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLArray uMLArray2 = null ;
      de.uni_paderborn.fujaba.uml.UMLArray uMLArray5 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr1 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr4 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass3 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr1 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLArray2: UMLArray
            fujaba__TmpObject = uMLAttr1.getAttrType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLArray ) ;
            uMLArray2 = (de.uni_paderborn.fujaba.uml.UMLArray) fujaba__TmpObject ;
             
            // bind uMLClass3: UMLClass
            fujaba__TmpObject = uMLArray2.getArrayType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            uMLClass3 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
             
            {
               //  for each flow
               try
               {
                  fujaba__Success = false ;
                   
                  // check object uMLAttr1 is really bound
                  JavaSDM.ensure ( uMLAttr1 != null ) ;
                   
                  // check object uMLClass3 is really bound
                  JavaSDM.ensure ( uMLClass3 != null ) ;
                   
                  // bind arrayMultiReference: ArrayMultiReferenceAnnotation
                  fujaba__IterUMLClass3AnnotationsArrayMultiReference = uMLClass3.iteratorOfAnnotations () ;
                  while ( !(fujaba__Success) && fujaba__IterUMLClass3AnnotationsArrayMultiReference.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass3AnnotationsArrayMultiReference.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ArrayMultiReferenceAnnotation ) ;
                        arrayMultiReference = (ArrayMultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between arrayMultiReference and uMLClass3
                        JavaSDM.ensure ( arrayMultiReference.hasInElements ("references", uMLClass3) ) ;
                         
                        // check To-Many-Link 'elements' between arrayMultiReference and uMLAttr1
                        JavaSDM.ensure ( arrayMultiReference.hasInElements ("field", uMLAttr1) ) ;
                         
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( !(fujaba__Success) )
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // check object uMLAttr1 is really bound
                     JavaSDM.ensure ( uMLAttr1 != null ) ;
                      
                     // check object uMLClass3 is really bound
                     JavaSDM.ensure ( uMLClass3 != null ) ;
                      
                     // create object
                     arrayMultiReference = new ArrayMultiReferenceAnnotation ( ) ;
                      
                     // create link
                     arrayMultiReference.addToElements ("field", uMLAttr1);
                      
                     // create link
                     arrayMultiReference.addToElements ("references", uMLClass3);
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  return (arrayMultiReference) ;
               }
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object arrayMultiReference is really bound
            JavaSDM.ensure ( arrayMultiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass6 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLArray5: UMLArray
            uMLArray5 = uMLClass6.getRevArrayType () ;
            JavaSDM.ensure ( uMLArray5 != null ) ;
             
            // bind uMLAttr4: UMLAttr
            fujaba__IterUMLArray5RevAttrTypeUMLAttr4 = uMLArray5.iteratorOfRevAttrType () ;
            while ( fujaba__IterUMLArray5RevAttrTypeUMLAttr4.hasNext () )
            {
               try
               {
                  uMLAttr4 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLArray5RevAttrTypeUMLAttr4.next () ;
                   
                  {
                     //  for each flow
                     try
                     {
                        fujaba__Success = false ;
                         
                        // check object uMLAttr4 is really bound
                        JavaSDM.ensure ( uMLAttr4 != null ) ;
                         
                        // check object uMLClass6 is really bound
                        JavaSDM.ensure ( uMLClass6 != null ) ;
                         
                        // bind arrayMultiReference: ArrayMultiReferenceAnnotation
                        fujaba__IterUMLAttr4AnnotationsArrayMultiReference = uMLAttr4.iteratorOfAnnotations () ;
                        while ( !(fujaba__Success) && fujaba__IterUMLAttr4AnnotationsArrayMultiReference.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLAttr4AnnotationsArrayMultiReference.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ArrayMultiReferenceAnnotation ) ;
                              arrayMultiReference = (ArrayMultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between arrayMultiReference and uMLAttr4
                              JavaSDM.ensure ( arrayMultiReference.hasInElements ("field", uMLAttr4) ) ;
                               
                              // check To-Many-Link 'elements' between arrayMultiReference and uMLClass6
                              JavaSDM.ensure ( arrayMultiReference.hasInElements ("references", uMLClass6) ) ;
                               
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( !(fujaba__Success) )
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object uMLAttr4 is really bound
                           JavaSDM.ensure ( uMLAttr4 != null ) ;
                            
                           // check object uMLClass6 is really bound
                           JavaSDM.ensure ( uMLClass6 != null ) ;
                            
                           // create object
                           arrayMultiReference = new ArrayMultiReferenceAnnotation ( ) ;
                            
                           // create link
                           arrayMultiReference.addToElements ("field", uMLAttr4);
                            
                           // create link
                           arrayMultiReference.addToElements ("references", uMLClass6);
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (arrayMultiReference) ;
                     }
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object arrayMultiReference is really bound
            JavaSDM.ensure ( arrayMultiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (arrayMultiReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
