package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class AssociationEngine
extends GFRNEngine
{
   private  AssociationEngine()
   {
   }

   private static AssociationEngine theAssociationEngine;

   public static AssociationEngine get()
   {
      if (theAssociationEngine == null)
      {
         theAssociationEngine = new AssociationEngine ();
      }
      return theAssociationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      AssocSetMethodAnnotation assocSetMethod10 = null ;
      AssocSetMethodAnnotation assocSetMethod15 = null ;
      AssocSetMethodAnnotation assocSetMethod16 = null ;
      AssocSetMethodAnnotation assocSetMethod3 = null ;
      AssocSetMethodAnnotation assocSetMethod4 = null ;
      AssocSetMethodAnnotation assocSetMethod9 = null ;
      AssociationAnnotation association = null ;
      Iterator fujaba__IterAssocSetMethod10ElementsUMLMethod11 = null ;
      Iterator fujaba__IterAssocSetMethod10ElementsUMLMethod12 = null ;
      Iterator fujaba__IterAssocSetMethod15ElementsReference13 = null ;
      Iterator fujaba__IterAssocSetMethod15ElementsUMLMethod17 = null ;
      Iterator fujaba__IterAssocSetMethod15ElementsUMLMethod18 = null ;
      Iterator fujaba__IterAssocSetMethod16ElementsReference14 = null ;
      Iterator fujaba__IterAssocSetMethod3ElementsUMLMethod5 = null ;
      Iterator fujaba__IterAssocSetMethod3ElementsUMLMethod6 = null ;
      Iterator fujaba__IterAssocSetMethod4ElementsReference2 = null ;
      Iterator fujaba__IterAssocSetMethod9ElementsReference7 = null ;
      Iterator fujaba__IterReference14AnnotationsAssociation = null ;
      Iterator fujaba__IterReference1AnnotationsAssocSetMethod3 = null ;
      Iterator fujaba__IterReference1AnnotationsAssociation = null ;
      Iterator fujaba__IterReference8AnnotationsAssocSetMethod10 = null ;
      Iterator fujaba__IterReference8AnnotationsAssociation = null ;
      Iterator fujaba__IterUMLMethod11AnnotationsAssocSetMethod9 = null ;
      Iterator fujaba__IterUMLMethod17AnnotationsAssocSetMethod16 = null ;
      Iterator fujaba__IterUMLMethod5AnnotationsAssocSetMethod4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference1 = null ;
      ReferenceAnnotation reference13 = null ;
      ReferenceAnnotation reference14 = null ;
      ReferenceAnnotation reference2 = null ;
      ReferenceAnnotation reference7 = null ;
      ReferenceAnnotation reference8 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod11 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod12 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod17 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod18 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod5 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference1 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod3: AssocSetMethodAnnotation
            fujaba__IterReference1AnnotationsAssocSetMethod3 = reference1.iteratorOfAnnotations () ;
            while ( fujaba__IterReference1AnnotationsAssocSetMethod3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference1AnnotationsAssocSetMethod3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod3 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod3 and reference1
                  JavaSDM.ensure ( assocSetMethod3.hasInElements ("reference", reference1) ) ;
                   
                  // bind uMLMethod5: UMLMethod
                  fujaba__IterAssocSetMethod3ElementsUMLMethod5 = assocSetMethod3.iteratorOfElements ("setMethod") ;
                  while ( fujaba__IterAssocSetMethod3ElementsUMLMethod5.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod3ElementsUMLMethod5.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod5 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // bind uMLMethod6: UMLMethod
                        fujaba__IterAssocSetMethod3ElementsUMLMethod6 = assocSetMethod3.iteratorOfElements ("calledMethod") ;
                        while ( fujaba__IterAssocSetMethod3ElementsUMLMethod6.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssocSetMethod3ElementsUMLMethod6.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod6 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod5.equals (uMLMethod6)) ) ;
                               
                              // bind assocSetMethod4: AssocSetMethodAnnotation
                              fujaba__IterUMLMethod5AnnotationsAssocSetMethod4 = uMLMethod5.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod5AnnotationsAssocSetMethod4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod5AnnotationsAssocSetMethod4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                    assocSetMethod4 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between assocSetMethod4 and uMLMethod5
                                    JavaSDM.ensure ( assocSetMethod4.hasInElements ("calledMethod", uMLMethod5) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(assocSetMethod3.equals (assocSetMethod4)) ) ;
                                     
                                    // check To-Many-Link 'elements' between assocSetMethod4 and uMLMethod6
                                    JavaSDM.ensure ( assocSetMethod4.hasInElements ("setMethod", uMLMethod6) ) ;
                                     
                                    // bind reference2: ReferenceAnnotation
                                    fujaba__IterAssocSetMethod4ElementsReference2 = assocSetMethod4.iteratorOfElements ("reference") ;
                                    while ( fujaba__IterAssocSetMethod4ElementsReference2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAssocSetMethod4ElementsReference2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                          reference2 = (ReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object reference1 is really bound
                                                JavaSDM.ensure ( reference1 != null ) ;
                                                 
                                                // check object reference2 is really bound
                                                JavaSDM.ensure ( reference2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                                 
                                                // bind association: AssociationAnnotation
                                                fujaba__IterReference1AnnotationsAssociation = reference1.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReference1AnnotationsAssociation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReference1AnnotationsAssociation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssociationAnnotation ) ;
                                                      association = (AssociationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between association and reference1
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between association and reference2
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference2) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference1 is really bound
                                                   JavaSDM.ensure ( reference1 != null ) ;
                                                    
                                                   // check object reference2 is really bound
                                                   JavaSDM.ensure ( reference2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                                    
                                                   // create object
                                                   association = new AssociationAnnotation ( ) ;
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference1);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference1 is really bound
                                                   JavaSDM.ensure ( reference1 != null ) ;
                                                    
                                                   // check object reference2 is really bound
                                                   JavaSDM.ensure ( reference2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference1.equals (reference2)) ) ;
                                                    
                                                   // check object assocSetMethod3 is really bound
                                                   JavaSDM.ensure ( assocSetMethod3 != null ) ;
                                                    
                                                   // check object assocSetMethod4 is really bound
                                                   JavaSDM.ensure ( assocSetMethod4 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(assocSetMethod3.equals (assocSetMethod4)) ) ;
                                                    
                                                   // check object association is really bound
                                                   JavaSDM.ensure ( association != null ) ;
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference1);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference2);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod3);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod4);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (association) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object association is really bound
            JavaSDM.ensure ( association != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference8 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod10: AssocSetMethodAnnotation
            fujaba__IterReference8AnnotationsAssocSetMethod10 = reference8.iteratorOfAnnotations () ;
            while ( fujaba__IterReference8AnnotationsAssocSetMethod10.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference8AnnotationsAssocSetMethod10.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod10 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod10 and reference8
                  JavaSDM.ensure ( assocSetMethod10.hasInElements ("reference", reference8) ) ;
                   
                  // bind uMLMethod11: UMLMethod
                  fujaba__IterAssocSetMethod10ElementsUMLMethod11 = assocSetMethod10.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod10ElementsUMLMethod11.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod10ElementsUMLMethod11.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod11 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // bind uMLMethod12: UMLMethod
                        fujaba__IterAssocSetMethod10ElementsUMLMethod12 = assocSetMethod10.iteratorOfElements ("setMethod") ;
                        while ( fujaba__IterAssocSetMethod10ElementsUMLMethod12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssocSetMethod10ElementsUMLMethod12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod12 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod11.equals (uMLMethod12)) ) ;
                               
                              // bind assocSetMethod9: AssocSetMethodAnnotation
                              fujaba__IterUMLMethod11AnnotationsAssocSetMethod9 = uMLMethod11.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod11AnnotationsAssocSetMethod9.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod11AnnotationsAssocSetMethod9.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                    assocSetMethod9 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between assocSetMethod9 and uMLMethod11
                                    JavaSDM.ensure ( assocSetMethod9.hasInElements ("setMethod", uMLMethod11) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(assocSetMethod10.equals (assocSetMethod9)) ) ;
                                     
                                    // check To-Many-Link 'elements' between assocSetMethod9 and uMLMethod12
                                    JavaSDM.ensure ( assocSetMethod9.hasInElements ("calledMethod", uMLMethod12) ) ;
                                     
                                    // bind reference7: ReferenceAnnotation
                                    fujaba__IterAssocSetMethod9ElementsReference7 = assocSetMethod9.iteratorOfElements ("reference") ;
                                    while ( fujaba__IterAssocSetMethod9ElementsReference7.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAssocSetMethod9ElementsReference7.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                          reference7 = (ReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(reference8.equals (reference7)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object reference7 is really bound
                                                JavaSDM.ensure ( reference7 != null ) ;
                                                 
                                                // check object reference8 is really bound
                                                JavaSDM.ensure ( reference8 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(reference7.equals (reference8)) ) ;
                                                 
                                                // bind association: AssociationAnnotation
                                                fujaba__IterReference8AnnotationsAssociation = reference8.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReference8AnnotationsAssociation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReference8AnnotationsAssociation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssociationAnnotation ) ;
                                                      association = (AssociationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between association and reference8
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference8) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between association and reference7
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference7) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference7 is really bound
                                                   JavaSDM.ensure ( reference7 != null ) ;
                                                    
                                                   // check object reference8 is really bound
                                                   JavaSDM.ensure ( reference8 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference7.equals (reference8)) ) ;
                                                    
                                                   // create object
                                                   association = new AssociationAnnotation ( ) ;
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference7);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference8);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference7 is really bound
                                                   JavaSDM.ensure ( reference7 != null ) ;
                                                    
                                                   // check object reference8 is really bound
                                                   JavaSDM.ensure ( reference8 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference7.equals (reference8)) ) ;
                                                    
                                                   // check object assocSetMethod9 is really bound
                                                   JavaSDM.ensure ( assocSetMethod9 != null ) ;
                                                    
                                                   // check object assocSetMethod10 is really bound
                                                   JavaSDM.ensure ( assocSetMethod10 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(assocSetMethod9.equals (assocSetMethod10)) ) ;
                                                    
                                                   // check object association is really bound
                                                   JavaSDM.ensure ( association != null ) ;
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference7);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference8);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod9);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod10);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (association) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object association is really bound
            JavaSDM.ensure ( association != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod15 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod17: UMLMethod
            fujaba__IterAssocSetMethod15ElementsUMLMethod17 = assocSetMethod15.iteratorOfElements ("setMethod") ;
            while ( fujaba__IterAssocSetMethod15ElementsUMLMethod17.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod15ElementsUMLMethod17.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod17 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind uMLMethod18: UMLMethod
                  fujaba__IterAssocSetMethod15ElementsUMLMethod18 = assocSetMethod15.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod15ElementsUMLMethod18.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod15ElementsUMLMethod18.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod18 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod17.equals (uMLMethod18)) ) ;
                         
                        // bind reference13: ReferenceAnnotation
                        fujaba__IterAssocSetMethod15ElementsReference13 = assocSetMethod15.iteratorOfElements ("reference") ;
                        while ( fujaba__IterAssocSetMethod15ElementsReference13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAssocSetMethod15ElementsReference13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference13 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // bind assocSetMethod16: AssocSetMethodAnnotation
                              fujaba__IterUMLMethod17AnnotationsAssocSetMethod16 = uMLMethod17.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod17AnnotationsAssocSetMethod16.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod17AnnotationsAssocSetMethod16.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                    assocSetMethod16 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between assocSetMethod16 and uMLMethod17
                                    JavaSDM.ensure ( assocSetMethod16.hasInElements ("calledMethod", uMLMethod17) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(assocSetMethod15.equals (assocSetMethod16)) ) ;
                                     
                                    // check To-Many-Link 'elements' between assocSetMethod16 and uMLMethod18
                                    JavaSDM.ensure ( assocSetMethod16.hasInElements ("setMethod", uMLMethod18) ) ;
                                     
                                    // bind reference14: ReferenceAnnotation
                                    fujaba__IterAssocSetMethod16ElementsReference14 = assocSetMethod16.iteratorOfElements ("reference") ;
                                    while ( fujaba__IterAssocSetMethod16ElementsReference14.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAssocSetMethod16ElementsReference14.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                          reference14 = (ReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object reference13 is really bound
                                                JavaSDM.ensure ( reference13 != null ) ;
                                                 
                                                // check object reference14 is really bound
                                                JavaSDM.ensure ( reference14 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                                 
                                                // bind association: AssociationAnnotation
                                                fujaba__IterReference14AnnotationsAssociation = reference14.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReference14AnnotationsAssociation.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReference14AnnotationsAssociation.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssociationAnnotation ) ;
                                                      association = (AssociationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between association and reference14
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference14) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between association and reference13
                                                      JavaSDM.ensure ( association.hasInElements ("reference", reference13) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference13 is really bound
                                                   JavaSDM.ensure ( reference13 != null ) ;
                                                    
                                                   // check object reference14 is really bound
                                                   JavaSDM.ensure ( reference14 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                                    
                                                   // create object
                                                   association = new AssociationAnnotation ( ) ;
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference13);
                                                    
                                                   // create link
                                                   association.addToElements ("reference", reference14);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference13 is really bound
                                                   JavaSDM.ensure ( reference13 != null ) ;
                                                    
                                                   // check object reference14 is really bound
                                                   JavaSDM.ensure ( reference14 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(reference13.equals (reference14)) ) ;
                                                    
                                                   // check object assocSetMethod15 is really bound
                                                   JavaSDM.ensure ( assocSetMethod15 != null ) ;
                                                    
                                                   // check object assocSetMethod16 is really bound
                                                   JavaSDM.ensure ( assocSetMethod16 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(assocSetMethod15.equals (assocSetMethod16)) ) ;
                                                    
                                                   // check object association is really bound
                                                   JavaSDM.ensure ( association != null ) ;
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference13);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (reference14);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod15);
                                                    
                                                   // create link
                                                   association.addToAntecedentAnnos (assocSetMethod16);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (association) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object association is really bound
            JavaSDM.ensure ( association != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (association) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AssocSetMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AssocSetMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      AssocSetMethodAnnotation assocSetMethod19 = null ;
      AssocSetMethodAnnotation assocSetMethod21 = null ;
      AssocSetMethodAnnotation assocSetMethod22 = null ;
      AssocSetMethodAnnotation assocSetMethod24 = null ;
      AssocSetMethodAnnotation assocSetMethod26 = null ;
      AssocSetMethodAnnotation assocSetMethod27 = null ;
      AssocSetMethodAnnotation assocSetMethod29 = null ;
      Iterator fujaba__IterAssocSetMethod19ElementsUMLMethod20 = null ;
      Iterator fujaba__IterAssocSetMethod22ElementsUMLMethod23 = null ;
      Iterator fujaba__IterAssocSetMethod22ElementsUMLMethod25 = null ;
      Iterator fujaba__IterAssocSetMethod27ElementsUMLMethod28 = null ;
      Iterator fujaba__IterAssocSetMethod29ElementsUMLMethod30 = null ;
      Iterator fujaba__IterAssocSetMethod29ElementsUMLMethod31 = null ;
      Iterator fujaba__IterReference13AnnotationsAssocSetMethod22 = null ;
      Iterator fujaba__IterReference13AnnotationsAssocSetMethod29 = null ;
      Iterator fujaba__IterReference14AnnotationsAssocSetMethod19 = null ;
      Iterator fujaba__IterReference14AnnotationsAssocSetMethod27 = null ;
      Iterator fujaba__IterUMLMethod20AnnotationsAssocSetMethod21 = null ;
      Iterator fujaba__IterUMLMethod23AnnotationsAssocSetMethod24 = null ;
      Iterator fujaba__IterUMLMethod25AnnotationsAssocSetMethod26 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference13 = null ;
      ReferenceAnnotation reference14 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod20 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod23 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod25 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod28 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod30 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod31 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference14 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod19: AssocSetMethodAnnotation
            fujaba__IterReference14AnnotationsAssocSetMethod19 = reference14.iteratorOfAnnotations () ;
            while ( fujaba__IterReference14AnnotationsAssocSetMethod19.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference14AnnotationsAssocSetMethod19.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod19 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod19 and reference14
                  JavaSDM.ensure ( assocSetMethod19.hasInElements ("reference", reference14) ) ;
                   
                  // bind uMLMethod20: UMLMethod
                  fujaba__IterAssocSetMethod19ElementsUMLMethod20 = assocSetMethod19.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod19ElementsUMLMethod20.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod19ElementsUMLMethod20.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod20 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // bind assocSetMethod21: AssocSetMethodAnnotation
                        fujaba__IterUMLMethod20AnnotationsAssocSetMethod21 = uMLMethod20.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod20AnnotationsAssocSetMethod21.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod20AnnotationsAssocSetMethod21.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                              assocSetMethod21 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between assocSetMethod21 and uMLMethod20
                              JavaSDM.ensure ( assocSetMethod21.hasInElements ("setMethod", uMLMethod20) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(assocSetMethod19.equals (assocSetMethod21)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (assocSetMethod21);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod21 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (assocSetMethod21);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference13 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod22: AssocSetMethodAnnotation
            fujaba__IterReference13AnnotationsAssocSetMethod22 = reference13.iteratorOfAnnotations () ;
            while ( fujaba__IterReference13AnnotationsAssocSetMethod22.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference13AnnotationsAssocSetMethod22.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod22 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod22 and reference13
                  JavaSDM.ensure ( assocSetMethod22.hasInElements ("reference", reference13) ) ;
                   
                  // bind uMLMethod23: UMLMethod
                  fujaba__IterAssocSetMethod22ElementsUMLMethod23 = assocSetMethod22.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod22ElementsUMLMethod23.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod22ElementsUMLMethod23.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod23 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // bind assocSetMethod24: AssocSetMethodAnnotation
                        fujaba__IterUMLMethod23AnnotationsAssocSetMethod24 = uMLMethod23.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod23AnnotationsAssocSetMethod24.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod23AnnotationsAssocSetMethod24.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                              assocSetMethod24 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between assocSetMethod24 and uMLMethod23
                              JavaSDM.ensure ( assocSetMethod24.hasInElements ("setMethod", uMLMethod23) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(assocSetMethod22.equals (assocSetMethod24)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (assocSetMethod24);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod22 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod25: UMLMethod
            fujaba__IterAssocSetMethod22ElementsUMLMethod25 = assocSetMethod22.iteratorOfElements ("calledMethod") ;
            while ( fujaba__IterAssocSetMethod22ElementsUMLMethod25.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod22ElementsUMLMethod25.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod25 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind assocSetMethod26: AssocSetMethodAnnotation
                  fujaba__IterUMLMethod25AnnotationsAssocSetMethod26 = uMLMethod25.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod25AnnotationsAssocSetMethod26.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod25AnnotationsAssocSetMethod26.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                        assocSetMethod26 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between assocSetMethod26 and uMLMethod25
                        JavaSDM.ensure ( assocSetMethod26.hasInElements ("setMethod", uMLMethod25) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(assocSetMethod22.equals (assocSetMethod26)) ) ;
                         
                        {
                           //  for each flow
                           set.add (assocSetMethod26);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("AssocSetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference13 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (reference13);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference14 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod27: AssocSetMethodAnnotation
            fujaba__IterReference14AnnotationsAssocSetMethod27 = reference14.iteratorOfAnnotations () ;
            while ( fujaba__IterReference14AnnotationsAssocSetMethod27.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference14AnnotationsAssocSetMethod27.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod27 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod27 and reference14
                  JavaSDM.ensure ( assocSetMethod27.hasInElements ("reference", reference14) ) ;
                   
                  // bind uMLMethod28: UMLMethod
                  fujaba__IterAssocSetMethod27ElementsUMLMethod28 = assocSetMethod27.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod27ElementsUMLMethod28.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod27ElementsUMLMethod28.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod28 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod28);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("AssocSetMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference13 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind assocSetMethod29: AssocSetMethodAnnotation
            fujaba__IterReference13AnnotationsAssocSetMethod29 = reference13.iteratorOfAnnotations () ;
            while ( fujaba__IterReference13AnnotationsAssocSetMethod29.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference13AnnotationsAssocSetMethod29.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                  assocSetMethod29 = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assocSetMethod29 and reference13
                  JavaSDM.ensure ( assocSetMethod29.hasInElements ("reference", reference13) ) ;
                   
                  // bind uMLMethod30: UMLMethod
                  fujaba__IterAssocSetMethod29ElementsUMLMethod30 = assocSetMethod29.iteratorOfElements ("calledMethod") ;
                  while ( fujaba__IterAssocSetMethod29ElementsUMLMethod30.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssocSetMethod29ElementsUMLMethod30.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod30 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod30);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference14 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (reference14);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssocSetMethodAnnotation ) ;
             
            // explicit type cast
            assocSetMethod29 = (AssocSetMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod31: UMLMethod
            fujaba__IterAssocSetMethod29ElementsUMLMethod31 = assocSetMethod29.iteratorOfElements ("calledMethod") ;
            while ( fujaba__IterAssocSetMethod29ElementsUMLMethod31.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssocSetMethod29ElementsUMLMethod31.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod31 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod31);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
