package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLStereotype;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.IdentifierNode;

public class ClassAdapterEngine
extends GFRNEngine
{
   private  ClassAdapterEngine()
   {
   }

   private static ClassAdapterEngine theClassAdapterEngine;

   public static ClassAdapterEngine get()
   {
      if (theClassAdapterEngine == null)
      {
         theClassAdapterEngine = new ClassAdapterEngine ();
      }
      return theClassAdapterEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterRootToMethodCallNode10 = null ;
      ASTPathVisitor fujaba__IterRootToMethodCallNode15 = null ;
      ASTPathVisitor fujaba__IterRootToMethodCallNode20 = null ;
      ASTPathVisitor fujaba__IterRootToMethodCallNode5 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      ClassAdapterAnnotation classAdapter = null ;
      Iterator fujaba__IterAdapteeAnnotationsClassAdapter = null ;
      Iterator fujaba__IterAdapteeAnnotationsGeneralization2 = null ;
      Iterator fujaba__IterAdapteeMethodsCallee = null ;
      Iterator fujaba__IterAdapterAnnotationsGeneralization12 = null ;
      Iterator fujaba__IterAdapterAnnotationsGeneralization17 = null ;
      Iterator fujaba__IterAdapterAnnotationsGeneralization7 = null ;
      Iterator fujaba__IterAdapterMethodsCaller = null ;
      Iterator fujaba__IterCallerAnnotationsOverridingMethod3 = null ;
      Iterator fujaba__IterCallerAnnotationsOverridingMethod8 = null ;
      Iterator fujaba__IterGeneralization12ElementsAdaptee = null ;
      Iterator fujaba__IterGeneralization17ElementsAdaptee = null ;
      Iterator fujaba__IterGeneralization2ElementsAdapter = null ;
      Iterator fujaba__IterGeneralization7ElementsAdaptee = null ;
      Iterator fujaba__IterOverridingMethod13ElementsCaller = null ;
      Iterator fujaba__IterOverridingMethod13ElementsUMLMethod14 = null ;
      Iterator fujaba__IterOverridingMethod18ElementsCaller = null ;
      Iterator fujaba__IterOverridingMethod3ElementsUMLMethod4 = null ;
      Iterator fujaba__IterOverridingMethod8ElementsUMLMethod9 = null ;
      Iterator fujaba__IterTargetAnnotationsClassAdapter = null ;
      Iterator fujaba__IterTargetMethodsUMLMethod19 = null ;
      Iterator fujaba__IterTargetStereotypesUMLStereotype1 = null ;
      Iterator fujaba__IterTargetStereotypesUMLStereotype11 = null ;
      Iterator fujaba__IterTargetStereotypesUMLStereotype16 = null ;
      Iterator fujaba__IterTargetStereotypesUMLStereotype6 = null ;
      Iterator fujaba__IterUMLMethod19AnnotationsOverridingMethod18 = null ;
      GeneralizationAnnotation generalization12 = null ;
      GeneralizationAnnotation generalization17 = null ;
      GeneralizationAnnotation generalization2 = null ;
      GeneralizationAnnotation generalization7 = null ;
      de.upb.javaast.methodast.IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode10 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode15 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode20 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode5 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod13 = null ;
      OverridingMethodAnnotation overridingMethod18 = null ;
      OverridingMethodAnnotation overridingMethod3 = null ;
      OverridingMethodAnnotation overridingMethod8 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adaptee = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adapter = null ;
      de.uni_paderborn.fujaba.uml.UMLClass target = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod14 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod19 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod4 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod9 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype1 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype11 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype16 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("adaptee", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
            while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                   
                  // bind generalization2: GeneralizationAnnotation
                  fujaba__IterAdapteeAnnotationsGeneralization2 = adaptee.iteratorOfAnnotations () ;
                  while ( fujaba__IterAdapteeAnnotationsGeneralization2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAdapteeAnnotationsGeneralization2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization2 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization2 and adaptee
                        JavaSDM.ensure ( generalization2.hasInElements ("superClass", adaptee) ) ;
                         
                        // bind adapter: UMLClass
                        fujaba__IterGeneralization2ElementsAdapter = generalization2.iteratorOfElements ("subClass") ;
                        while ( fujaba__IterGeneralization2ElementsAdapter.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization2ElementsAdapter.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(adaptee.equals (adapter)) ) ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
                              while ( fujaba__IterAdapterMethodsCaller.hasNext () )
                              {
                                 try
                                 {
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // bind overridingMethod3: OverridingMethodAnnotation
                                    fujaba__IterCallerAnnotationsOverridingMethod3 = caller.iteratorOfAnnotations () ;
                                    while ( fujaba__IterCallerAnnotationsOverridingMethod3.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCallerAnnotationsOverridingMethod3.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod3 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod3 and caller
                                          JavaSDM.ensure ( overridingMethod3.hasInElements ("overriding", caller) ) ;
                                           
                                          // bind uMLMethod4: UMLMethod
                                          fujaba__IterOverridingMethod3ElementsUMLMethod4 = overridingMethod3.iteratorOfElements ("overridden") ;
                                          while ( fujaba__IterOverridingMethod3ElementsUMLMethod4.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOverridingMethod3ElementsUMLMethod4.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                uMLMethod4 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (uMLMethod4)) && !(callee.equals (uMLMethod4)) ) ;
                                                 
                                                // bind target: UMLClass
                                                target = uMLMethod4.getParent () ;
                                                JavaSDM.ensure ( target != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(adaptee.equals (target)) && !(adapter.equals (target)) ) ;
                                                 
                                                // bind uMLStereotype1: UMLStereotype
                                                fujaba__IterTargetStereotypesUMLStereotype1 = target.iteratorOfStereotypes () ;
                                                while ( fujaba__IterTargetStereotypesUMLStereotype1.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLStereotype1 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterTargetStereotypesUMLStereotype1.next () ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype1.getText (), "interface") == 0) ) ;
                                                       
                                                      // Path search between ASTRootNode and MethodCallNode
                                                      // Bind methodCallNode5 : MethodCallNode
                                                      fujaba__IterRootToMethodCallNode5 = new ASTPathVisitor (root, MethodCallNode.class ) ;
                                                      while ( fujaba__IterRootToMethodCallNode5.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            methodCallNode5 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterRootToMethodCallNode5.next () ;
                                                             
                                                            // bind id: IdentifierNode
                                                            id = methodCallNode5.getIdentifier () ;
                                                            JavaSDM.ensure ( id != null ) ;
                                                             
                                                            // constraint
                                                            JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object adaptee is really bound
                                                                  JavaSDM.ensure ( adaptee != null ) ;
                                                                   
                                                                  // check object target is really bound
                                                                  JavaSDM.ensure ( target != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                   
                                                                  // check object adapter is really bound
                                                                  JavaSDM.ensure ( adapter != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                   
                                                                  // bind classAdapter: ClassAdapterAnnotation
                                                                  fujaba__IterTargetAnnotationsClassAdapter = target.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterTargetAnnotationsClassAdapter.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterTargetAnnotationsClassAdapter.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof ClassAdapterAnnotation ) ;
                                                                        classAdapter = (ClassAdapterAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between classAdapter and target
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("target", target) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between classAdapter and adaptee
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between classAdapter and adapter
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("adapter", adapter) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object adaptee is really bound
                                                                     JavaSDM.ensure ( adaptee != null ) ;
                                                                      
                                                                     // check object target is really bound
                                                                     JavaSDM.ensure ( target != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                      
                                                                     // check object adapter is really bound
                                                                     JavaSDM.ensure ( adapter != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                      
                                                                     // check object caller is really bound
                                                                     JavaSDM.ensure ( caller != null ) ;
                                                                      
                                                                     // check object root is really bound
                                                                     JavaSDM.ensure ( root != null ) ;
                                                                      
                                                                     // check object id is really bound
                                                                     JavaSDM.ensure ( id != null ) ;
                                                                      
                                                                     // check object callee is really bound
                                                                     JavaSDM.ensure ( callee != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                      
                                                                     // create object
                                                                     classAdapter = new ClassAdapterAnnotation ( ) ;
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("adaptee", adaptee);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("target", target);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("adapter", adapter);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("adaptee", adaptee);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("adapter", adapter);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("caller", caller);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("target", target);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("root", root);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("id", id);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("callee", callee);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object generalization2 is really bound
                                                                     JavaSDM.ensure ( generalization2 != null ) ;
                                                                      
                                                                     // check object overridingMethod3 is really bound
                                                                     JavaSDM.ensure ( overridingMethod3 != null ) ;
                                                                      
                                                                     // check object classAdapter is really bound
                                                                     JavaSDM.ensure ( classAdapter != null ) ;
                                                                      
                                                                     // create link
                                                                     classAdapter.addToAntecedentAnnos (generalization2);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToAntecedentAnnos (overridingMethod3);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (classAdapter) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object classAdapter is really bound
            JavaSDM.ensure ( classAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("adaptee", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("adapter", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
            while ( fujaba__IterAdapterMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                   
                  // bind root: ASTRootNode
                  root = caller.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // bind generalization7: GeneralizationAnnotation
                  fujaba__IterAdapterAnnotationsGeneralization7 = adapter.iteratorOfAnnotations () ;
                  while ( fujaba__IterAdapterAnnotationsGeneralization7.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAdapterAnnotationsGeneralization7.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization7 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization7 and adapter
                        JavaSDM.ensure ( generalization7.hasInElements ("subClass", adapter) ) ;
                         
                        // bind overridingMethod8: OverridingMethodAnnotation
                        fujaba__IterCallerAnnotationsOverridingMethod8 = caller.iteratorOfAnnotations () ;
                        while ( fujaba__IterCallerAnnotationsOverridingMethod8.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCallerAnnotationsOverridingMethod8.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod8 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod8 and caller
                              JavaSDM.ensure ( overridingMethod8.hasInElements ("overriding", caller) ) ;
                               
                              // bind adaptee: UMLClass
                              fujaba__IterGeneralization7ElementsAdaptee = generalization7.iteratorOfElements ("superClass") ;
                              while ( fujaba__IterGeneralization7ElementsAdaptee.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterGeneralization7ElementsAdaptee.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(adapter.equals (adaptee)) ) ;
                                     
                                    // bind uMLMethod9: UMLMethod
                                    fujaba__IterOverridingMethod8ElementsUMLMethod9 = overridingMethod8.iteratorOfElements ("overridden") ;
                                    while ( fujaba__IterOverridingMethod8ElementsUMLMethod9.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOverridingMethod8ElementsUMLMethod9.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          uMLMethod9 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (uMLMethod9)) ) ;
                                           
                                          // bind target: UMLClass
                                          target = uMLMethod9.getParent () ;
                                          JavaSDM.ensure ( target != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(adaptee.equals (target)) && !(adapter.equals (target)) ) ;
                                           
                                          // bind callee: UMLMethod
                                          fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
                                          while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
                                          {
                                             try
                                             {
                                                callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) && !(uMLMethod9.equals (callee)) ) ;
                                                 
                                                // bind uMLStereotype6: UMLStereotype
                                                fujaba__IterTargetStereotypesUMLStereotype6 = target.iteratorOfStereotypes () ;
                                                while ( fujaba__IterTargetStereotypesUMLStereotype6.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLStereotype6 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterTargetStereotypesUMLStereotype6.next () ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype6.getText (), "interface") == 0) ) ;
                                                       
                                                      // Path search between ASTRootNode and MethodCallNode
                                                      // Bind methodCallNode10 : MethodCallNode
                                                      fujaba__IterRootToMethodCallNode10 = new ASTPathVisitor (root, MethodCallNode.class ) ;
                                                      while ( fujaba__IterRootToMethodCallNode10.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            methodCallNode10 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterRootToMethodCallNode10.next () ;
                                                             
                                                            // bind id: IdentifierNode
                                                            id = methodCallNode10.getIdentifier () ;
                                                            JavaSDM.ensure ( id != null ) ;
                                                             
                                                            // constraint
                                                            JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object adaptee is really bound
                                                                  JavaSDM.ensure ( adaptee != null ) ;
                                                                   
                                                                  // check object target is really bound
                                                                  JavaSDM.ensure ( target != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                   
                                                                  // check object adapter is really bound
                                                                  JavaSDM.ensure ( adapter != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                   
                                                                  // bind classAdapter: ClassAdapterAnnotation
                                                                  fujaba__IterTargetAnnotationsClassAdapter = target.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterTargetAnnotationsClassAdapter.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterTargetAnnotationsClassAdapter.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof ClassAdapterAnnotation ) ;
                                                                        classAdapter = (ClassAdapterAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between classAdapter and target
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("target", target) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between classAdapter and adaptee
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between classAdapter and adapter
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("adapter", adapter) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object adaptee is really bound
                                                                     JavaSDM.ensure ( adaptee != null ) ;
                                                                      
                                                                     // check object target is really bound
                                                                     JavaSDM.ensure ( target != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                      
                                                                     // check object adapter is really bound
                                                                     JavaSDM.ensure ( adapter != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                      
                                                                     // check object caller is really bound
                                                                     JavaSDM.ensure ( caller != null ) ;
                                                                      
                                                                     // check object root is really bound
                                                                     JavaSDM.ensure ( root != null ) ;
                                                                      
                                                                     // check object id is really bound
                                                                     JavaSDM.ensure ( id != null ) ;
                                                                      
                                                                     // check object callee is really bound
                                                                     JavaSDM.ensure ( callee != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                      
                                                                     // create object
                                                                     classAdapter = new ClassAdapterAnnotation ( ) ;
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("adaptee", adaptee);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("target", target);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("adapter", adapter);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("adaptee", adaptee);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("adapter", adapter);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("caller", caller);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("target", target);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("root", root);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("id", id);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("callee", callee);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object generalization7 is really bound
                                                                     JavaSDM.ensure ( generalization7 != null ) ;
                                                                      
                                                                     // check object overridingMethod8 is really bound
                                                                     JavaSDM.ensure ( overridingMethod8 != null ) ;
                                                                      
                                                                     // check object classAdapter is really bound
                                                                     JavaSDM.ensure ( classAdapter != null ) ;
                                                                      
                                                                     // create link
                                                                     classAdapter.addToAntecedentAnnos (generalization7);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToAntecedentAnnos (overridingMethod8);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (classAdapter) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object classAdapter is really bound
            JavaSDM.ensure ( classAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("adapter", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod13 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterOverridingMethod13ElementsCaller = overridingMethod13.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod13ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod13ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind root: ASTRootNode
                  root = caller.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // bind adapter: UMLClass
                  adapter = caller.getParent () ;
                  JavaSDM.ensure ( adapter != null ) ;
                   
                  // bind uMLMethod14: UMLMethod
                  fujaba__IterOverridingMethod13ElementsUMLMethod14 = overridingMethod13.iteratorOfElements ("overridden") ;
                  while ( fujaba__IterOverridingMethod13ElementsUMLMethod14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOverridingMethod13ElementsUMLMethod14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod14 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(caller.equals (uMLMethod14)) ) ;
                         
                        // bind target: UMLClass
                        target = uMLMethod14.getParent () ;
                        JavaSDM.ensure ( target != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(adapter.equals (target)) ) ;
                         
                        // bind generalization12: GeneralizationAnnotation
                        fujaba__IterAdapterAnnotationsGeneralization12 = adapter.iteratorOfAnnotations () ;
                        while ( fujaba__IterAdapterAnnotationsGeneralization12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAdapterAnnotationsGeneralization12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization12 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization12 and adapter
                              JavaSDM.ensure ( generalization12.hasInElements ("subClass", adapter) ) ;
                               
                              // bind uMLStereotype11: UMLStereotype
                              fujaba__IterTargetStereotypesUMLStereotype11 = target.iteratorOfStereotypes () ;
                              while ( fujaba__IterTargetStereotypesUMLStereotype11.hasNext () )
                              {
                                 try
                                 {
                                    uMLStereotype11 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterTargetStereotypesUMLStereotype11.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype11.getText (), "interface") == 0) ) ;
                                     
                                    // bind adaptee: UMLClass
                                    fujaba__IterGeneralization12ElementsAdaptee = generalization12.iteratorOfElements ("superClass") ;
                                    while ( fujaba__IterGeneralization12ElementsAdaptee.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization12ElementsAdaptee.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(adapter.equals (adaptee)) && !(target.equals (adaptee)) ) ;
                                           
                                          // bind callee: UMLMethod
                                          fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
                                          while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
                                          {
                                             try
                                             {
                                                callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) && !(uMLMethod14.equals (callee)) ) ;
                                                 
                                                // Path search between ASTRootNode and MethodCallNode
                                                // Bind methodCallNode15 : MethodCallNode
                                                fujaba__IterRootToMethodCallNode15 = new ASTPathVisitor (root, MethodCallNode.class ) ;
                                                while ( fujaba__IterRootToMethodCallNode15.hasNext () )
                                                {
                                                   try
                                                   {
                                                      methodCallNode15 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterRootToMethodCallNode15.next () ;
                                                       
                                                      // bind id: IdentifierNode
                                                      id = methodCallNode15.getIdentifier () ;
                                                      JavaSDM.ensure ( id != null ) ;
                                                       
                                                      // constraint
                                                      JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object adaptee is really bound
                                                            JavaSDM.ensure ( adaptee != null ) ;
                                                             
                                                            // check object target is really bound
                                                            JavaSDM.ensure ( target != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                             
                                                            // check object adapter is really bound
                                                            JavaSDM.ensure ( adapter != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                             
                                                            // bind classAdapter: ClassAdapterAnnotation
                                                            fujaba__IterAdapteeAnnotationsClassAdapter = adaptee.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAdapteeAnnotationsClassAdapter.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAdapteeAnnotationsClassAdapter.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof ClassAdapterAnnotation ) ;
                                                                  classAdapter = (ClassAdapterAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between classAdapter and adaptee
                                                                  JavaSDM.ensure ( classAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between classAdapter and target
                                                                  JavaSDM.ensure ( classAdapter.hasInElements ("target", target) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between classAdapter and adapter
                                                                  JavaSDM.ensure ( classAdapter.hasInElements ("adapter", adapter) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object adaptee is really bound
                                                               JavaSDM.ensure ( adaptee != null ) ;
                                                                
                                                               // check object target is really bound
                                                               JavaSDM.ensure ( target != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                
                                                               // check object adapter is really bound
                                                               JavaSDM.ensure ( adapter != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                
                                                               // check object caller is really bound
                                                               JavaSDM.ensure ( caller != null ) ;
                                                                
                                                               // check object root is really bound
                                                               JavaSDM.ensure ( root != null ) ;
                                                                
                                                               // check object id is really bound
                                                               JavaSDM.ensure ( id != null ) ;
                                                                
                                                               // check object callee is really bound
                                                               JavaSDM.ensure ( callee != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                
                                                               // create object
                                                               classAdapter = new ClassAdapterAnnotation ( ) ;
                                                                
                                                               // create link
                                                               classAdapter.addToElements ("adaptee", adaptee);
                                                                
                                                               // create link
                                                               classAdapter.addToElements ("target", target);
                                                                
                                                               // create link
                                                               classAdapter.addToElements ("adapter", adapter);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("adaptee", adaptee);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("adapter", adapter);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("caller", caller);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("target", target);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("root", root);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("id", id);
                                                                
                                                               // create link
                                                               classAdapter.addToBoundObjects ("callee", callee);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization12 is really bound
                                                               JavaSDM.ensure ( generalization12 != null ) ;
                                                                
                                                               // check object overridingMethod13 is really bound
                                                               JavaSDM.ensure ( overridingMethod13 != null ) ;
                                                                
                                                               // check object classAdapter is really bound
                                                               JavaSDM.ensure ( classAdapter != null ) ;
                                                                
                                                               // create link
                                                               classAdapter.addToAntecedentAnnos (generalization12);
                                                                
                                                               // create link
                                                               classAdapter.addToAntecedentAnnos (overridingMethod13);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (classAdapter) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object classAdapter is really bound
            JavaSDM.ensure ( classAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("target", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod19: UMLMethod
            fujaba__IterTargetMethodsUMLMethod19 = target.iteratorOfMethods () ;
            while ( fujaba__IterTargetMethodsUMLMethod19.hasNext () )
            {
               try
               {
                  uMLMethod19 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterTargetMethodsUMLMethod19.next () ;
                   
                  // bind uMLStereotype16: UMLStereotype
                  fujaba__IterTargetStereotypesUMLStereotype16 = target.iteratorOfStereotypes () ;
                  while ( fujaba__IterTargetStereotypesUMLStereotype16.hasNext () )
                  {
                     try
                     {
                        uMLStereotype16 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterTargetStereotypesUMLStereotype16.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype16.getText (), "interface") == 0) ) ;
                         
                        // bind overridingMethod18: OverridingMethodAnnotation
                        fujaba__IterUMLMethod19AnnotationsOverridingMethod18 = uMLMethod19.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod19AnnotationsOverridingMethod18.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod19AnnotationsOverridingMethod18.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod18 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod18 and uMLMethod19
                              JavaSDM.ensure ( overridingMethod18.hasInElements ("overridden", uMLMethod19) ) ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterOverridingMethod18ElementsCaller = overridingMethod18.iteratorOfElements ("overriding") ;
                              while ( fujaba__IterOverridingMethod18ElementsCaller.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod18ElementsCaller.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod19.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // bind adapter: UMLClass
                                    adapter = caller.getParent () ;
                                    JavaSDM.ensure ( adapter != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                                     
                                    // bind generalization17: GeneralizationAnnotation
                                    fujaba__IterAdapterAnnotationsGeneralization17 = adapter.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAdapterAnnotationsGeneralization17.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAdapterAnnotationsGeneralization17.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization17 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization17 and adapter
                                          JavaSDM.ensure ( generalization17.hasInElements ("subClass", adapter) ) ;
                                           
                                          // bind adaptee: UMLClass
                                          fujaba__IterGeneralization17ElementsAdaptee = generalization17.iteratorOfElements ("superClass") ;
                                          while ( fujaba__IterGeneralization17ElementsAdaptee.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization17ElementsAdaptee.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(adapter.equals (adaptee)) && !(target.equals (adaptee)) ) ;
                                                 
                                                // bind callee: UMLMethod
                                                fujaba__IterAdapteeMethodsCallee = adaptee.iteratorOfMethods () ;
                                                while ( fujaba__IterAdapteeMethodsCallee.hasNext () )
                                                {
                                                   try
                                                   {
                                                      callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapteeMethodsCallee.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) && !(uMLMethod19.equals (callee)) ) ;
                                                       
                                                      // Path search between ASTRootNode and MethodCallNode
                                                      // Bind methodCallNode20 : MethodCallNode
                                                      fujaba__IterRootToMethodCallNode20 = new ASTPathVisitor (root, MethodCallNode.class ) ;
                                                      while ( fujaba__IterRootToMethodCallNode20.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            methodCallNode20 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterRootToMethodCallNode20.next () ;
                                                             
                                                            // bind id: IdentifierNode
                                                            id = methodCallNode20.getIdentifier () ;
                                                            JavaSDM.ensure ( id != null ) ;
                                                             
                                                            // constraint
                                                            JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object adaptee is really bound
                                                                  JavaSDM.ensure ( adaptee != null ) ;
                                                                   
                                                                  // check object target is really bound
                                                                  JavaSDM.ensure ( target != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                   
                                                                  // check object adapter is really bound
                                                                  JavaSDM.ensure ( adapter != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                   
                                                                  // bind classAdapter: ClassAdapterAnnotation
                                                                  fujaba__IterTargetAnnotationsClassAdapter = target.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterTargetAnnotationsClassAdapter.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterTargetAnnotationsClassAdapter.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof ClassAdapterAnnotation ) ;
                                                                        classAdapter = (ClassAdapterAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between classAdapter and target
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("target", target) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between classAdapter and adaptee
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("adaptee", adaptee) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between classAdapter and adapter
                                                                        JavaSDM.ensure ( classAdapter.hasInElements ("adapter", adapter) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object adaptee is really bound
                                                                     JavaSDM.ensure ( adaptee != null ) ;
                                                                      
                                                                     // check object target is really bound
                                                                     JavaSDM.ensure ( target != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(adaptee.equals (target)) ) ;
                                                                      
                                                                     // check object adapter is really bound
                                                                     JavaSDM.ensure ( adapter != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(adaptee.equals (adapter)) && !(target.equals (adapter)) ) ;
                                                                      
                                                                     // check object caller is really bound
                                                                     JavaSDM.ensure ( caller != null ) ;
                                                                      
                                                                     // check object root is really bound
                                                                     JavaSDM.ensure ( root != null ) ;
                                                                      
                                                                     // check object id is really bound
                                                                     JavaSDM.ensure ( id != null ) ;
                                                                      
                                                                     // check object callee is really bound
                                                                     JavaSDM.ensure ( callee != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                      
                                                                     // create object
                                                                     classAdapter = new ClassAdapterAnnotation ( ) ;
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("adaptee", adaptee);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("target", target);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToElements ("adapter", adapter);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("adaptee", adaptee);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("adapter", adapter);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("caller", caller);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("target", target);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("root", root);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("id", id);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToBoundObjects ("callee", callee);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object generalization17 is really bound
                                                                     JavaSDM.ensure ( generalization17 != null ) ;
                                                                      
                                                                     // check object overridingMethod18 is really bound
                                                                     JavaSDM.ensure ( overridingMethod18 != null ) ;
                                                                      
                                                                     // check object classAdapter is really bound
                                                                     JavaSDM.ensure ( classAdapter != null ) ;
                                                                      
                                                                     // create link
                                                                     classAdapter.addToAntecedentAnnos (generalization17);
                                                                      
                                                                     // create link
                                                                     classAdapter.addToAntecedentAnnos (overridingMethod18);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (classAdapter) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object classAdapter is really bound
            JavaSDM.ensure ( classAdapter != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("target", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (classAdapter) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("adaptee", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("target", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("adapter", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAdapteeAnnotationsGeneralization23 = null ;
      Iterator fujaba__IterAdapterMethodsCaller = null ;
      Iterator fujaba__IterGeneralization23ElementsAdapter = null ;
      Iterator fujaba__IterOverridingMethod22ElementsCaller = null ;
      Iterator fujaba__IterTargetMethodsUMLMethod21 = null ;
      Iterator fujaba__IterTargetMethodsUMLMethod24 = null ;
      Iterator fujaba__IterUMLMethod21AnnotationsOverridingMethod22 = null ;
      GeneralizationAnnotation generalization23 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod22 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adaptee = null ;
      de.uni_paderborn.fujaba.uml.UMLClass adapter = null ;
      de.uni_paderborn.fujaba.uml.UMLClass target = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod21 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod24 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (adaptee);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod21: UMLMethod
            fujaba__IterTargetMethodsUMLMethod21 = target.iteratorOfMethods () ;
            while ( fujaba__IterTargetMethodsUMLMethod21.hasNext () )
            {
               try
               {
                  uMLMethod21 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterTargetMethodsUMLMethod21.next () ;
                   
                  // bind overridingMethod22: OverridingMethodAnnotation
                  fujaba__IterUMLMethod21AnnotationsOverridingMethod22 = uMLMethod21.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod21AnnotationsOverridingMethod22.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod21AnnotationsOverridingMethod22.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod22 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod22 and uMLMethod21
                        JavaSDM.ensure ( overridingMethod22.hasInElements ("overridden", uMLMethod21) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterOverridingMethod22ElementsCaller = overridingMethod22.iteratorOfElements ("overriding") ;
                        while ( fujaba__IterOverridingMethod22ElementsCaller.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOverridingMethod22ElementsCaller.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod21.equals (caller)) ) ;
                               
                              // bind adapter: UMLClass
                              adapter = caller.getParent () ;
                              JavaSDM.ensure ( adapter != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(target.equals (adapter)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (adapter);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (adapter);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod22 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterOverridingMethod22ElementsCaller = overridingMethod22.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod22ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod22ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind adapter: UMLClass
                  adapter = caller.getParent () ;
                  JavaSDM.ensure ( adapter != null ) ;
                   
                  {
                     //  for each flow
                     set.add (adapter);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adaptee = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization23: GeneralizationAnnotation
            fujaba__IterAdapteeAnnotationsGeneralization23 = adaptee.iteratorOfAnnotations () ;
            while ( fujaba__IterAdapteeAnnotationsGeneralization23.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAdapteeAnnotationsGeneralization23.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization23 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization23 and adaptee
                  JavaSDM.ensure ( generalization23.hasInElements ("superClass", adaptee) ) ;
                   
                  // bind adapter: UMLClass
                  fujaba__IterGeneralization23ElementsAdapter = generalization23.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization23ElementsAdapter.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization23ElementsAdapter.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(adaptee.equals (adapter)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
                        while ( fujaba__IterAdapterMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                               
                              {
                                 //  for each flow
                                 set.add (caller);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            target = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod24: UMLMethod
            fujaba__IterTargetMethodsUMLMethod24 = target.iteratorOfMethods () ;
            while ( fujaba__IterTargetMethodsUMLMethod24.hasNext () )
            {
               try
               {
                  uMLMethod24 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterTargetMethodsUMLMethod24.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod24);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            adapter = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterAdapterMethodsCaller = adapter.iteratorOfMethods () ;
            while ( fujaba__IterAdapterMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAdapterMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
