package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class CompositeEngine
extends GFRNEngine
{
   private  CompositeEngine()
   {
   }

   private static CompositeEngine theCompositeEngine;

   public static CompositeEngine get()
   {
      if (theCompositeEngine == null)
      {
         theCompositeEngine = new CompositeEngine ();
      }
      return theCompositeEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CompositeAnnotation composite = null ;
      Iterator fujaba__IterCalleeAnnotationsMultiDelegation8 = null ;
      Iterator fujaba__IterCallerAnnotationsMultiDelegation5 = null ;
      Iterator fujaba__IterComponentClassAnnotationsGeneralization3 = null ;
      Iterator fujaba__IterComponentClassAnnotationsGeneralization9 = null ;
      Iterator fujaba__IterComponentClassAnnotationsOneToManyAssociation1 = null ;
      Iterator fujaba__IterComponentClassAnnotationsOneToManyAssociation7 = null ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterCompositeClassAnnotationsComposite = null ;
      Iterator fujaba__IterCompositeClassAnnotationsGeneralization6 = null ;
      Iterator fujaba__IterCompositeClassAnnotationsOneToManyAssociation4 = null ;
      Iterator fujaba__IterCompositeClassMethodsCaller = null ;
      Iterator fujaba__IterGeneralization6ElementsComponentClass = null ;
      Iterator fujaba__IterGeneralization9ElementsCompositeClass = null ;
      Iterator fujaba__IterMultiDelegation2ElementsCallee = null ;
      Iterator fujaba__IterMultiDelegation2ElementsCaller = null ;
      Iterator fujaba__IterMultiDelegation5ElementsCallee = null ;
      Iterator fujaba__IterMultiDelegation8ElementsCaller = null ;
      GeneralizationAnnotation generalization3 = null ;
      GeneralizationAnnotation generalization6 = null ;
      GeneralizationAnnotation generalization9 = null ;
      MultiDelegationAnnotation multiDelegation2 = null ;
      MultiDelegationAnnotation multiDelegation5 = null ;
      MultiDelegationAnnotation multiDelegation8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation1 = null ;
      OneToManyAssociationAnnotation oneToManyAssociation4 = null ;
      OneToManyAssociationAnnotation oneToManyAssociation7 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass componentClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass compositeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiDelegationAnnotation ) ;
             
            // explicit type cast
            multiDelegation2 = (MultiDelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterMultiDelegation2ElementsCallee = multiDelegation2.iteratorOfElements ("callee") ;
            while ( fujaba__IterMultiDelegation2ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiDelegation2ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  componentClass = callee.getParent () ;
                  JavaSDM.ensure ( componentClass != null ) ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterMultiDelegation2ElementsCaller = multiDelegation2.iteratorOfElements ("caller") ;
                  while ( fujaba__IterMultiDelegation2ElementsCaller.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiDelegation2ElementsCaller.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                         
                        // bind compositeClass: UMLClass
                        compositeClass = caller.getParent () ;
                        JavaSDM.ensure ( compositeClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(componentClass.equals (compositeClass)) ) ;
                         
                        // bind generalization3: GeneralizationAnnotation
                        fujaba__IterComponentClassAnnotationsGeneralization3 = componentClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterComponentClassAnnotationsGeneralization3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterComponentClassAnnotationsGeneralization3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization3 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization3 and componentClass
                              JavaSDM.ensure ( generalization3.hasInElements ("superClass", componentClass) ) ;
                               
                              // check To-Many-Link 'elements' between generalization3 and compositeClass
                              JavaSDM.ensure ( generalization3.hasInElements ("subClass", compositeClass) ) ;
                               
                              // bind oneToManyAssociation1: OneToManyAssociationAnnotation
                              fujaba__IterComponentClassAnnotationsOneToManyAssociation1 = componentClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterComponentClassAnnotationsOneToManyAssociation1.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterComponentClassAnnotationsOneToManyAssociation1.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                                    oneToManyAssociation1 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between oneToManyAssociation1 and componentClass
                                    JavaSDM.ensure ( oneToManyAssociation1.hasInElements ("many", componentClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between oneToManyAssociation1 and compositeClass
                                    JavaSDM.ensure ( oneToManyAssociation1.hasInElements ("one", compositeClass) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object compositeClass is really bound
                                          JavaSDM.ensure ( compositeClass != null ) ;
                                           
                                          // check object componentClass is really bound
                                          JavaSDM.ensure ( componentClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                           
                                          // bind composite: CompositeAnnotation
                                          fujaba__IterCompositeClassAnnotationsComposite = compositeClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterCompositeClassAnnotationsComposite.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsComposite.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between composite and compositeClass
                                                JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between composite and componentClass
                                                JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object compositeClass is really bound
                                             JavaSDM.ensure ( compositeClass != null ) ;
                                              
                                             // check object componentClass is really bound
                                             JavaSDM.ensure ( componentClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                              
                                             // check object callee is really bound
                                             JavaSDM.ensure ( callee != null ) ;
                                              
                                             // check object caller is really bound
                                             JavaSDM.ensure ( caller != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                              
                                             // create object
                                             composite = new CompositeAnnotation ( ) ;
                                              
                                             // create link
                                             composite.addToElements ("composite", compositeClass);
                                              
                                             // create link
                                             composite.addToElements ("component", componentClass);
                                              
                                             // create link
                                             composite.addToBoundObjects ("callee", callee);
                                              
                                             // create link
                                             composite.addToBoundObjects ("compositeClass", compositeClass);
                                              
                                             // create link
                                             composite.addToBoundObjects ("componentClass", componentClass);
                                              
                                             // create link
                                             composite.addToBoundObjects ("caller", caller);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object oneToManyAssociation1 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation1 != null ) ;
                                              
                                             // check object multiDelegation2 is really bound
                                             JavaSDM.ensure ( multiDelegation2 != null ) ;
                                              
                                             // check object generalization3 is really bound
                                             JavaSDM.ensure ( generalization3 != null ) ;
                                              
                                             // check object composite is really bound
                                             JavaSDM.ensure ( composite != null ) ;
                                              
                                             // create link
                                             composite.addToAntecedentAnnos (oneToManyAssociation1);
                                              
                                             // create link
                                             composite.addToAntecedentAnnos (multiDelegation2);
                                              
                                             // create link
                                             composite.addToAntecedentAnnos (generalization3);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (composite) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("composite", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterCompositeClassMethodsCaller = compositeClass.iteratorOfMethods () ;
            while ( fujaba__IterCompositeClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCompositeClassMethodsCaller.next () ;
                   
                  // bind generalization6: GeneralizationAnnotation
                  fujaba__IterCompositeClassAnnotationsGeneralization6 = compositeClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterCompositeClassAnnotationsGeneralization6.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsGeneralization6.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization6 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization6 and compositeClass
                        JavaSDM.ensure ( generalization6.hasInElements ("subClass", compositeClass) ) ;
                         
                        // bind oneToManyAssociation4: OneToManyAssociationAnnotation
                        fujaba__IterCompositeClassAnnotationsOneToManyAssociation4 = compositeClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterCompositeClassAnnotationsOneToManyAssociation4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsOneToManyAssociation4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation4 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation4 and compositeClass
                              JavaSDM.ensure ( oneToManyAssociation4.hasInElements ("one", compositeClass) ) ;
                               
                              // bind multiDelegation5: MultiDelegationAnnotation
                              fujaba__IterCallerAnnotationsMultiDelegation5 = caller.iteratorOfAnnotations () ;
                              while ( fujaba__IterCallerAnnotationsMultiDelegation5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCallerAnnotationsMultiDelegation5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiDelegationAnnotation ) ;
                                    multiDelegation5 = (MultiDelegationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiDelegation5 and caller
                                    JavaSDM.ensure ( multiDelegation5.hasInElements ("caller", caller) ) ;
                                     
                                    // bind componentClass: UMLClass
                                    fujaba__IterGeneralization6ElementsComponentClass = generalization6.iteratorOfElements ("superClass") ;
                                    while ( fujaba__IterGeneralization6ElementsComponentClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization6ElementsComponentClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                           
                                          // check To-Many-Link 'elements' between oneToManyAssociation4 and componentClass
                                          JavaSDM.ensure ( oneToManyAssociation4.hasInElements ("many", componentClass) ) ;
                                           
                                          // bind callee: UMLMethod
                                          fujaba__IterMultiDelegation5ElementsCallee = multiDelegation5.iteratorOfElements ("callee") ;
                                          while ( fujaba__IterMultiDelegation5ElementsCallee.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMultiDelegation5ElementsCallee.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check To-One-Link 'parent' between callee and componentClass
                                                JavaSDM.ensure ( (callee.getParent () != null) && callee.getParent ().equals (componentClass) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object compositeClass is really bound
                                                      JavaSDM.ensure ( compositeClass != null ) ;
                                                       
                                                      // check object componentClass is really bound
                                                      JavaSDM.ensure ( componentClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                       
                                                      // bind composite: CompositeAnnotation
                                                      fujaba__IterCompositeClassAnnotationsComposite = compositeClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCompositeClassAnnotationsComposite.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsComposite.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                            composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between composite and compositeClass
                                                            JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between composite and componentClass
                                                            JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object compositeClass is really bound
                                                         JavaSDM.ensure ( compositeClass != null ) ;
                                                          
                                                         // check object componentClass is really bound
                                                         JavaSDM.ensure ( componentClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         composite = new CompositeAnnotation ( ) ;
                                                          
                                                         // create link
                                                         composite.addToElements ("composite", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToElements ("component", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("compositeClass", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("componentClass", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("caller", caller);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object oneToManyAssociation4 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation4 != null ) ;
                                                          
                                                         // check object multiDelegation5 is really bound
                                                         JavaSDM.ensure ( multiDelegation5 != null ) ;
                                                          
                                                         // check object generalization6 is really bound
                                                         JavaSDM.ensure ( generalization6 != null ) ;
                                                          
                                                         // check object composite is really bound
                                                         JavaSDM.ensure ( composite != null ) ;
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (oneToManyAssociation4);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (multiDelegation5);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (generalization6);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (composite) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("composite", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("component", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
            while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                   
                  // bind generalization9: GeneralizationAnnotation
                  fujaba__IterComponentClassAnnotationsGeneralization9 = componentClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterComponentClassAnnotationsGeneralization9.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterComponentClassAnnotationsGeneralization9.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization9 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization9 and componentClass
                        JavaSDM.ensure ( generalization9.hasInElements ("superClass", componentClass) ) ;
                         
                        // bind oneToManyAssociation7: OneToManyAssociationAnnotation
                        fujaba__IterComponentClassAnnotationsOneToManyAssociation7 = componentClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterComponentClassAnnotationsOneToManyAssociation7.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterComponentClassAnnotationsOneToManyAssociation7.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                              oneToManyAssociation7 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between oneToManyAssociation7 and componentClass
                              JavaSDM.ensure ( oneToManyAssociation7.hasInElements ("many", componentClass) ) ;
                               
                              // bind multiDelegation8: MultiDelegationAnnotation
                              fujaba__IterCalleeAnnotationsMultiDelegation8 = callee.iteratorOfAnnotations () ;
                              while ( fujaba__IterCalleeAnnotationsMultiDelegation8.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCalleeAnnotationsMultiDelegation8.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiDelegationAnnotation ) ;
                                    multiDelegation8 = (MultiDelegationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiDelegation8 and callee
                                    JavaSDM.ensure ( multiDelegation8.hasInElements ("callee", callee) ) ;
                                     
                                    // bind compositeClass: UMLClass
                                    fujaba__IterGeneralization9ElementsCompositeClass = generalization9.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization9ElementsCompositeClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization9ElementsCompositeClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          compositeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(componentClass.equals (compositeClass)) ) ;
                                           
                                          // check To-Many-Link 'elements' between oneToManyAssociation7 and compositeClass
                                          JavaSDM.ensure ( oneToManyAssociation7.hasInElements ("one", compositeClass) ) ;
                                           
                                          // bind caller: UMLMethod
                                          fujaba__IterMultiDelegation8ElementsCaller = multiDelegation8.iteratorOfElements ("caller") ;
                                          while ( fujaba__IterMultiDelegation8ElementsCaller.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMultiDelegation8ElementsCaller.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                 
                                                // check To-One-Link 'parent' between caller and compositeClass
                                                JavaSDM.ensure ( (caller.getParent () != null) && caller.getParent ().equals (compositeClass) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object compositeClass is really bound
                                                      JavaSDM.ensure ( compositeClass != null ) ;
                                                       
                                                      // check object componentClass is really bound
                                                      JavaSDM.ensure ( componentClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                       
                                                      // bind composite: CompositeAnnotation
                                                      fujaba__IterCompositeClassAnnotationsComposite = compositeClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCompositeClassAnnotationsComposite.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCompositeClassAnnotationsComposite.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof CompositeAnnotation ) ;
                                                            composite = (CompositeAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between composite and compositeClass
                                                            JavaSDM.ensure ( composite.hasInElements ("composite", compositeClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between composite and componentClass
                                                            JavaSDM.ensure ( composite.hasInElements ("component", componentClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object compositeClass is really bound
                                                         JavaSDM.ensure ( compositeClass != null ) ;
                                                          
                                                         // check object componentClass is really bound
                                                         JavaSDM.ensure ( componentClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(compositeClass.equals (componentClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // create object
                                                         composite = new CompositeAnnotation ( ) ;
                                                          
                                                         // create link
                                                         composite.addToElements ("composite", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToElements ("component", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("compositeClass", compositeClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("componentClass", componentClass);
                                                          
                                                         // create link
                                                         composite.addToBoundObjects ("caller", caller);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object oneToManyAssociation7 is really bound
                                                         JavaSDM.ensure ( oneToManyAssociation7 != null ) ;
                                                          
                                                         // check object multiDelegation8 is really bound
                                                         JavaSDM.ensure ( multiDelegation8 != null ) ;
                                                          
                                                         // check object generalization9 is really bound
                                                         JavaSDM.ensure ( generalization9 != null ) ;
                                                          
                                                         // check object composite is really bound
                                                         JavaSDM.ensure ( composite != null ) ;
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (oneToManyAssociation7);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (multiDelegation8);
                                                          
                                                         // create link
                                                         composite.addToAntecedentAnnos (generalization9);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (composite) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object composite is really bound
            JavaSDM.ensure ( composite != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("component", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (composite) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("composite", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("component", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OneToManyAssociationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiDelegationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterCompositeClassMethodsCaller = null ;
      Iterator fujaba__IterMultiDelegation8ElementsCallee = null ;
      MultiDelegationAnnotation multiDelegation8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass componentClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass compositeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("OneToManyAssociation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (compositeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiDelegationAnnotation ) ;
             
            // explicit type cast
            multiDelegation8 = (MultiDelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterMultiDelegation8ElementsCallee = multiDelegation8.iteratorOfElements ("callee") ;
            while ( fujaba__IterMultiDelegation8ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiDelegation8ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  componentClass = callee.getParent () ;
                  JavaSDM.ensure ( componentClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (componentClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("MultiDelegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterCompositeClassMethodsCaller = compositeClass.iteratorOfMethods () ;
            while ( fujaba__IterCompositeClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCompositeClassMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
            while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                   
                  {
                     //  for each flow
                     set.add (callee);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            compositeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (compositeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiDelegationAnnotation ) ;
             
            // explicit type cast
            multiDelegation8 = (MultiDelegationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterMultiDelegation8ElementsCallee = multiDelegation8.iteratorOfElements ("callee") ;
            while ( fujaba__IterMultiDelegation8ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiDelegation8ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind componentClass: UMLClass
                  componentClass = callee.getParent () ;
                  JavaSDM.ensure ( componentClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (componentClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
