package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class FactoryMethodEngine
extends GFRNEngine
{
   private  FactoryMethodEngine()
   {
   }

   private static FactoryMethodEngine theFactoryMethodEngine;

   public static FactoryMethodEngine get()
   {
      if (theFactoryMethodEngine == null)
      {
         theFactoryMethodEngine = new FactoryMethodEngine ();
      }
      return theFactoryMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod1 = null ;
      CreateMethodAnnotation createMethod3 = null ;
      CreateMethodAnnotation createMethod5 = null ;
      CreateMethodAnnotation createMethod7 = null ;
      Iterator fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod = null ;
      Iterator fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod6 = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod1 = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod3 = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod5 = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod2 = null ;
      Iterator fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod8 = null ;
      Iterator fujaba__IterCreateMethod1ElementsProductClass = null ;
      Iterator fujaba__IterCreateMethod3ElementsProductClass = null ;
      Iterator fujaba__IterCreateMethod5ElementsProductClass = null ;
      Iterator fujaba__IterCreateMethod7ElementsConcreteFactoryMethod = null ;
      Iterator fujaba__IterOverridingMethod2ElementsAbstractFactoryMethod = null ;
      Iterator fujaba__IterOverridingMethod4ElementsAbstractFactoryMethod = null ;
      Iterator fujaba__IterOverridingMethod4ElementsConcreteFactoryMethod = null ;
      Iterator fujaba__IterOverridingMethod6ElementsConcreteFactoryMethod = null ;
      Iterator fujaba__IterOverridingMethod8ElementsAbstractFactoryMethod = null ;
      Iterator fujaba__IterProductClassAnnotationsCreateMethod7 = null ;
      Iterator fujaba__IterProductClassAnnotationsFactoryMethod = null ;
      FactoryMethodAnnotation factoryMethod = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod2 = null ;
      OverridingMethodAnnotation overridingMethod4 = null ;
      OverridingMethodAnnotation overridingMethod6 = null ;
      OverridingMethodAnnotation overridingMethod8 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass productClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod abstractFactoryMethod = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod concreteFactoryMethod = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("concreteMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
             
            // bind createMethod1: CreateMethodAnnotation
            fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod1 = concreteFactoryMethod.iteratorOfAnnotations () ;
            while ( fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                  createMethod1 = (CreateMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between createMethod1 and concreteFactoryMethod
                  JavaSDM.ensure ( createMethod1.hasInElements ("method", concreteFactoryMethod) ) ;
                   
                  // bind overridingMethod2: OverridingMethodAnnotation
                  fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod2 = concreteFactoryMethod.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        overridingMethod2 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between overridingMethod2 and concreteFactoryMethod
                        JavaSDM.ensure ( overridingMethod2.hasInElements ("overriding", concreteFactoryMethod) ) ;
                         
                        // bind productClass: UMLClass
                        fujaba__IterCreateMethod1ElementsProductClass = createMethod1.iteratorOfElements ("creates") ;
                        while ( fujaba__IterCreateMethod1ElementsProductClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCreateMethod1ElementsProductClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              productClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // bind abstractFactoryMethod: UMLMethod
                              fujaba__IterOverridingMethod2ElementsAbstractFactoryMethod = overridingMethod2.iteratorOfElements ("overridden") ;
                              while ( fujaba__IterOverridingMethod2ElementsAbstractFactoryMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod2ElementsAbstractFactoryMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    abstractFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object abstractFactoryMethod is really bound
                                          JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                           
                                          // check object concreteFactoryMethod is really bound
                                          JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                           
                                          // check object productClass is really bound
                                          JavaSDM.ensure ( productClass != null ) ;
                                           
                                          // bind factoryMethod: FactoryMethodAnnotation
                                          fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod = abstractFactoryMethod.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractFactoryMethodAnnotationsFactoryMethod.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FactoryMethodAnnotation ) ;
                                                factoryMethod = (FactoryMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between factoryMethod and abstractFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("abstractMethod", abstractFactoryMethod) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and concreteFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("concreteMethod", concreteFactoryMethod) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and productClass
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("product", productClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object abstractFactoryMethod is really bound
                                             JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                              
                                             // check object concreteFactoryMethod is really bound
                                             JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                              
                                             // check object productClass is really bound
                                             JavaSDM.ensure ( productClass != null ) ;
                                              
                                             // create object
                                             factoryMethod = new FactoryMethodAnnotation ( ) ;
                                              
                                             // create link
                                             factoryMethod.addToElements ("abstractMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("concreteMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("product", productClass);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("productClass", productClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod1 is really bound
                                             JavaSDM.ensure ( createMethod1 != null ) ;
                                              
                                             // check object overridingMethod2 is really bound
                                             JavaSDM.ensure ( overridingMethod2 != null ) ;
                                              
                                             // check object factoryMethod is really bound
                                             JavaSDM.ensure ( factoryMethod != null ) ;
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (createMethod1);
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (overridingMethod2);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (factoryMethod) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object factoryMethod is really bound
            JavaSDM.ensure ( factoryMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("concreteMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod4 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteFactoryMethod: UMLMethod
            fujaba__IterOverridingMethod4ElementsConcreteFactoryMethod = overridingMethod4.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod4ElementsConcreteFactoryMethod.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod4ElementsConcreteFactoryMethod.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                   
                  // bind abstractFactoryMethod: UMLMethod
                  fujaba__IterOverridingMethod4ElementsAbstractFactoryMethod = overridingMethod4.iteratorOfElements ("overridden") ;
                  while ( fujaba__IterOverridingMethod4ElementsAbstractFactoryMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOverridingMethod4ElementsAbstractFactoryMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        abstractFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                         
                        // bind createMethod3: CreateMethodAnnotation
                        fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod3 = concreteFactoryMethod.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod3 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod3 and concreteFactoryMethod
                              JavaSDM.ensure ( createMethod3.hasInElements ("method", concreteFactoryMethod) ) ;
                               
                              // bind productClass: UMLClass
                              fujaba__IterCreateMethod3ElementsProductClass = createMethod3.iteratorOfElements ("creates") ;
                              while ( fujaba__IterCreateMethod3ElementsProductClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod3ElementsProductClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    productClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object abstractFactoryMethod is really bound
                                          JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                           
                                          // check object concreteFactoryMethod is really bound
                                          JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                           
                                          // check object productClass is really bound
                                          JavaSDM.ensure ( productClass != null ) ;
                                           
                                          // bind factoryMethod: FactoryMethodAnnotation
                                          fujaba__IterProductClassAnnotationsFactoryMethod = productClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterProductClassAnnotationsFactoryMethod.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterProductClassAnnotationsFactoryMethod.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FactoryMethodAnnotation ) ;
                                                factoryMethod = (FactoryMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between factoryMethod and productClass
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("product", productClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and abstractFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("abstractMethod", abstractFactoryMethod) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and concreteFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("concreteMethod", concreteFactoryMethod) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object abstractFactoryMethod is really bound
                                             JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                              
                                             // check object concreteFactoryMethod is really bound
                                             JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                              
                                             // check object productClass is really bound
                                             JavaSDM.ensure ( productClass != null ) ;
                                              
                                             // create object
                                             factoryMethod = new FactoryMethodAnnotation ( ) ;
                                              
                                             // create link
                                             factoryMethod.addToElements ("abstractMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("concreteMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("product", productClass);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("productClass", productClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod3 is really bound
                                             JavaSDM.ensure ( createMethod3 != null ) ;
                                              
                                             // check object overridingMethod4 is really bound
                                             JavaSDM.ensure ( overridingMethod4 != null ) ;
                                              
                                             // check object factoryMethod is really bound
                                             JavaSDM.ensure ( factoryMethod != null ) ;
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (createMethod3);
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (overridingMethod4);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (factoryMethod) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object factoryMethod is really bound
            JavaSDM.ensure ( factoryMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("abstractMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            abstractFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
             
            // bind overridingMethod6: OverridingMethodAnnotation
            fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod6 = abstractFactoryMethod.iteratorOfAnnotations () ;
            while ( fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod6.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod6.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                  overridingMethod6 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between overridingMethod6 and abstractFactoryMethod
                  JavaSDM.ensure ( overridingMethod6.hasInElements ("overridden", abstractFactoryMethod) ) ;
                   
                  // bind concreteFactoryMethod: UMLMethod
                  fujaba__IterOverridingMethod6ElementsConcreteFactoryMethod = overridingMethod6.iteratorOfElements ("overriding") ;
                  while ( fujaba__IterOverridingMethod6ElementsConcreteFactoryMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOverridingMethod6ElementsConcreteFactoryMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                         
                        // bind createMethod5: CreateMethodAnnotation
                        fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod5 = concreteFactoryMethod.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsCreateMethod5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod5 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod5 and concreteFactoryMethod
                              JavaSDM.ensure ( createMethod5.hasInElements ("method", concreteFactoryMethod) ) ;
                               
                              // bind productClass: UMLClass
                              fujaba__IterCreateMethod5ElementsProductClass = createMethod5.iteratorOfElements ("creates") ;
                              while ( fujaba__IterCreateMethod5ElementsProductClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod5ElementsProductClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    productClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object abstractFactoryMethod is really bound
                                          JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                           
                                          // check object concreteFactoryMethod is really bound
                                          JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                           
                                          // check object productClass is really bound
                                          JavaSDM.ensure ( productClass != null ) ;
                                           
                                          // bind factoryMethod: FactoryMethodAnnotation
                                          fujaba__IterProductClassAnnotationsFactoryMethod = productClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterProductClassAnnotationsFactoryMethod.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterProductClassAnnotationsFactoryMethod.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FactoryMethodAnnotation ) ;
                                                factoryMethod = (FactoryMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between factoryMethod and productClass
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("product", productClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and abstractFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("abstractMethod", abstractFactoryMethod) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and concreteFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("concreteMethod", concreteFactoryMethod) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object abstractFactoryMethod is really bound
                                             JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                              
                                             // check object concreteFactoryMethod is really bound
                                             JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                              
                                             // check object productClass is really bound
                                             JavaSDM.ensure ( productClass != null ) ;
                                              
                                             // create object
                                             factoryMethod = new FactoryMethodAnnotation ( ) ;
                                              
                                             // create link
                                             factoryMethod.addToElements ("abstractMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("concreteMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("product", productClass);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("productClass", productClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod5 is really bound
                                             JavaSDM.ensure ( createMethod5 != null ) ;
                                              
                                             // check object overridingMethod6 is really bound
                                             JavaSDM.ensure ( overridingMethod6 != null ) ;
                                              
                                             // check object factoryMethod is really bound
                                             JavaSDM.ensure ( factoryMethod != null ) ;
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (createMethod5);
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (overridingMethod6);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (factoryMethod) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object factoryMethod is really bound
            JavaSDM.ensure ( factoryMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("abstractMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("product", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            productClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind createMethod7: CreateMethodAnnotation
            fujaba__IterProductClassAnnotationsCreateMethod7 = productClass.iteratorOfAnnotations () ;
            while ( fujaba__IterProductClassAnnotationsCreateMethod7.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterProductClassAnnotationsCreateMethod7.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                  createMethod7 = (CreateMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between createMethod7 and productClass
                  JavaSDM.ensure ( createMethod7.hasInElements ("creates", productClass) ) ;
                   
                  // bind concreteFactoryMethod: UMLMethod
                  fujaba__IterCreateMethod7ElementsConcreteFactoryMethod = createMethod7.iteratorOfElements ("method") ;
                  while ( fujaba__IterCreateMethod7ElementsConcreteFactoryMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCreateMethod7ElementsConcreteFactoryMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                         
                        // bind overridingMethod8: OverridingMethodAnnotation
                        fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod8 = concreteFactoryMethod.iteratorOfAnnotations () ;
                        while ( fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod8.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsOverridingMethod8.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod8 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod8 and concreteFactoryMethod
                              JavaSDM.ensure ( overridingMethod8.hasInElements ("overriding", concreteFactoryMethod) ) ;
                               
                              // bind abstractFactoryMethod: UMLMethod
                              fujaba__IterOverridingMethod8ElementsAbstractFactoryMethod = overridingMethod8.iteratorOfElements ("overridden") ;
                              while ( fujaba__IterOverridingMethod8ElementsAbstractFactoryMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingMethod8ElementsAbstractFactoryMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    abstractFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (abstractFactoryMethod.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteFactoryMethod.equals (abstractFactoryMethod)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object abstractFactoryMethod is really bound
                                          JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                           
                                          // check object concreteFactoryMethod is really bound
                                          JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                           
                                          // check object productClass is really bound
                                          JavaSDM.ensure ( productClass != null ) ;
                                           
                                          // bind factoryMethod: FactoryMethodAnnotation
                                          fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod = concreteFactoryMethod.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterConcreteFactoryMethodAnnotationsFactoryMethod.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FactoryMethodAnnotation ) ;
                                                factoryMethod = (FactoryMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between factoryMethod and concreteFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("concreteMethod", concreteFactoryMethod) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and abstractFactoryMethod
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("abstractMethod", abstractFactoryMethod) ) ;
                                                 
                                                // check To-Many-Link 'elements' between factoryMethod and productClass
                                                JavaSDM.ensure ( factoryMethod.hasInElements ("product", productClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object abstractFactoryMethod is really bound
                                             JavaSDM.ensure ( abstractFactoryMethod != null ) ;
                                              
                                             // check object concreteFactoryMethod is really bound
                                             JavaSDM.ensure ( concreteFactoryMethod != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                                              
                                             // check object productClass is really bound
                                             JavaSDM.ensure ( productClass != null ) ;
                                              
                                             // create object
                                             factoryMethod = new FactoryMethodAnnotation ( ) ;
                                              
                                             // create link
                                             factoryMethod.addToElements ("abstractMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("concreteMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToElements ("product", productClass);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("concreteFactoryMethod", concreteFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("abstractFactoryMethod", abstractFactoryMethod);
                                              
                                             // create link
                                             factoryMethod.addToBoundObjects ("productClass", productClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object createMethod7 is really bound
                                             JavaSDM.ensure ( createMethod7 != null ) ;
                                              
                                             // check object overridingMethod8 is really bound
                                             JavaSDM.ensure ( overridingMethod8 != null ) ;
                                              
                                             // check object factoryMethod is really bound
                                             JavaSDM.ensure ( factoryMethod != null ) ;
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (createMethod7);
                                              
                                             // create link
                                             factoryMethod.addToAntecedentAnnos (overridingMethod8);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (factoryMethod) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object factoryMethod is really bound
            JavaSDM.ensure ( factoryMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("product", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (factoryMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("abstractMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("concreteMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("product", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod10 = null ;
      Iterator fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod9 = null ;
      Iterator fujaba__IterCreateMethod10ElementsConcreteFactoryMethod = null ;
      Iterator fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod = null ;
      Iterator fujaba__IterProductClassAnnotationsCreateMethod10 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod9 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass productClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod abstractFactoryMethod = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod concreteFactoryMethod = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("CreateMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            abstractFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind overridingMethod9: OverridingMethodAnnotation
            fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod9 = abstractFactoryMethod.iteratorOfAnnotations () ;
            while ( fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod9.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAbstractFactoryMethodAnnotationsOverridingMethod9.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                  overridingMethod9 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between overridingMethod9 and abstractFactoryMethod
                  JavaSDM.ensure ( overridingMethod9.hasInElements ("overridden", abstractFactoryMethod) ) ;
                   
                  // bind concreteFactoryMethod: UMLMethod
                  fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod = overridingMethod9.iteratorOfElements ("overriding") ;
                  while ( fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(abstractFactoryMethod.equals (concreteFactoryMethod)) ) ;
                         
                        {
                           //  for each flow
                           set.add (concreteFactoryMethod);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (concreteFactoryMethod);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            productClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (productClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod9 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteFactoryMethod: UMLMethod
            fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod = overridingMethod9.iteratorOfElements ("overriding") ;
            while ( fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod9ElementsConcreteFactoryMethod.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteFactoryMethod);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            abstractFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractFactoryMethod);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (concreteFactoryMethod);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            productClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind createMethod10: CreateMethodAnnotation
            fujaba__IterProductClassAnnotationsCreateMethod10 = productClass.iteratorOfAnnotations () ;
            while ( fujaba__IterProductClassAnnotationsCreateMethod10.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterProductClassAnnotationsCreateMethod10.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                  createMethod10 = (CreateMethodAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between createMethod10 and productClass
                  JavaSDM.ensure ( createMethod10.hasInElements ("creates", productClass) ) ;
                   
                  // bind concreteFactoryMethod: UMLMethod
                  fujaba__IterCreateMethod10ElementsConcreteFactoryMethod = createMethod10.iteratorOfElements ("method") ;
                  while ( fujaba__IterCreateMethod10ElementsConcreteFactoryMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCreateMethod10ElementsConcreteFactoryMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        concreteFactoryMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteFactoryMethod.isAbstract () == false) ) ;
                         
                        {
                           //  for each flow
                           set.add (concreteFactoryMethod);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
