package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLStereotype;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class ImplementationVariantEngine
extends GFRNEngine
{
   private  ImplementationVariantEngine()
   {
   }

   private static ImplementationVariantEngine theImplementationVariantEngine;

   public static ImplementationVariantEngine get()
   {
      if (theImplementationVariantEngine == null)
      {
         theImplementationVariantEngine = new ImplementationVariantEngine ();
      }
      return theImplementationVariantEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      de.upb.tools.fca.FHashSet set1 = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterGeneralization2ElementsSuperClass = null ;
      Iterator fujaba__IterGeneralization5ElementsSubClass = null ;
      Iterator fujaba__IterGeneralization8ElementsSubClass = null ;
      Iterator fujaba__IterGeneralization8ElementsSuperClass = null ;
      Iterator fujaba__IterSet1 = null ;
      Iterator fujaba__IterSubClassAnnotationsGeneralization2 = null ;
      Iterator fujaba__IterSubClassAnnotationsImplementationVariant = null ;
      Iterator fujaba__IterSubClassAnnotationsMethodDecleration3 = null ;
      Iterator fujaba__IterSubClassAnnotationsMethodDecleration6 = null ;
      Iterator fujaba__IterSubClassAnnotationsMethodDecleration9 = null ;
      Iterator fujaba__IterSubClassStereotypesUMLStereotype1 = null ;
      Iterator fujaba__IterSubClassStereotypesUMLStereotype4 = null ;
      Iterator fujaba__IterSubClassStereotypesUMLStereotype7 = null ;
      Iterator fujaba__IterSuperClassAnnotationsGeneralization5 = null ;
      GeneralizationAnnotation generalization2 = null ;
      GeneralizationAnnotation generalization5 = null ;
      GeneralizationAnnotation generalization8 = null ;
      ImplementationVariantAnnotation implementationVariant = null ;
      MethodDeclerationAnnotation methodDecleration3 = null ;
      MethodDeclerationAnnotation methodDecleration6 = null ;
      MethodDeclerationAnnotation methodDecleration9 = null ;
      MultiLevelGeneralizationAnnotation fujaba__TmpObjectMultiLevelGeneralizationAnnotation = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass subClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass superClass = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype1 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype4 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("variant", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization2: GeneralizationAnnotation
            fujaba__IterSubClassAnnotationsGeneralization2 = subClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSubClassAnnotationsGeneralization2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSubClassAnnotationsGeneralization2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization2 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization2 and subClass
                  JavaSDM.ensure ( generalization2.hasInElements ("subClass", subClass) ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( (set1 == null) || !(set1.contains (generalization2)) ) ;
                   
                  // bind superClass: UMLClass
                  fujaba__IterGeneralization2ElementsSuperClass = generalization2.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization2ElementsSuperClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization2ElementsSuperClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                         
                        // check To-Many-Link 'stereotypes' between subClass and uMLStereotype1
                        fujaba__IterSubClassStereotypesUMLStereotype1 = subClass.iteratorOfStereotypes () ;
                        while ( fujaba__IterSubClassStereotypesUMLStereotype1.hasNext () )
                        {
                           uMLStereotype1 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterSubClassStereotypesUMLStereotype1.next () ;
                            
                           JavaSDM.ensure ( !((JavaSDM.stringCompare (uMLStereotype1.getText (), "interface") == 0)) ) ;
                        } // while
                         
                        // check To-Many-Link 'annotations' between subClass and methodDecleration3
                        fujaba__IterSubClassAnnotationsMethodDecleration3 = subClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterSubClassAnnotationsMethodDecleration3.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterSubClassAnnotationsMethodDecleration3.next () ;
                            
                           if ( fujaba__TmpObject instanceof MethodDeclerationAnnotation )
                           {
                              methodDecleration3 = (MethodDeclerationAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(methodDecleration3.hasInElements ("declaring", subClass)) ) ;
                           }
                        } // while
                         
                        // linkSearchToSetTop
                        set1 = new de.upb.tools.fca.FHashSet ( ) ;
                        fujaba__IterSet1 = subClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterSet1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterSet1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiLevelGeneralizationAnnotation ) ;
                              fujaba__TmpObjectMultiLevelGeneralizationAnnotation = (MultiLevelGeneralizationAnnotation) fujaba__TmpObject ;
                               
                              set1.remove (generalization2);
                              //  check link :) 'elements' between set1 and superClass
                              JavaSDM.ensure ( fujaba__TmpObjectMultiLevelGeneralizationAnnotation.hasInElements (superClass) ) ;
                               
                              set1.add (fujaba__TmpObjectMultiLevelGeneralizationAnnotation);
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        } // while
                        // constraint
                        JavaSDM.ensure ( set1.size() == 0 ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object subClass is really bound
                              JavaSDM.ensure ( subClass != null ) ;
                               
                              // check object superClass is really bound
                              JavaSDM.ensure ( superClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                               
                              // bind implementationVariant: ImplementationVariantAnnotation
                              fujaba__IterSubClassAnnotationsImplementationVariant = subClass.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterSubClassAnnotationsImplementationVariant.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterSubClassAnnotationsImplementationVariant.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ImplementationVariantAnnotation ) ;
                                    implementationVariant = (ImplementationVariantAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between implementationVariant and subClass
                                    JavaSDM.ensure ( implementationVariant.hasInElements ("variant", subClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between implementationVariant and superClass
                                    JavaSDM.ensure ( implementationVariant.hasInElements ("implements", superClass) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object subClass is really bound
                                 JavaSDM.ensure ( subClass != null ) ;
                                  
                                 // check object superClass is really bound
                                 JavaSDM.ensure ( superClass != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                                  
                                 // create object
                                 implementationVariant = new ImplementationVariantAnnotation ( ) ;
                                  
                                 // create link
                                 implementationVariant.addToElements ("variant", subClass);
                                  
                                 // create link
                                 implementationVariant.addToElements ("implements", superClass);
                                  
                                 // create link
                                 implementationVariant.addToBoundObjects ("subClass", subClass);
                                  
                                 // create link
                                 implementationVariant.addToBoundObjects ("superClass", superClass);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object generalization2 is really bound
                                 JavaSDM.ensure ( generalization2 != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( (set1 == null) || !(set1.contains (generalization2)) ) ;
                                  
                                 // check object implementationVariant is really bound
                                 JavaSDM.ensure ( implementationVariant != null ) ;
                                  
                                 // create link
                                 implementationVariant.addToAntecedentAnnos (generalization2);
                                  
                                 fujaba__IterSet1 = set1.iterator () ;
                                 while ( fujaba__IterSet1.hasNext () )
                                 {
                                    fujaba__TmpObjectMultiLevelGeneralizationAnnotation = (MultiLevelGeneralizationAnnotation) fujaba__IterSet1.next () ;
                                    //  create set link
                                    implementationVariant.addToAntecedentAnnos (fujaba__TmpObjectMultiLevelGeneralizationAnnotation);
                                    fujaba__Success = true ;
                                 } // while
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (implementationVariant) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object implementationVariant is really bound
            JavaSDM.ensure ( implementationVariant != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("variant", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("implements", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization5: GeneralizationAnnotation
            fujaba__IterSuperClassAnnotationsGeneralization5 = superClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSuperClassAnnotationsGeneralization5.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSuperClassAnnotationsGeneralization5.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization5 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization5 and superClass
                  JavaSDM.ensure ( generalization5.hasInElements ("superClass", superClass) ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( (set1 == null) || !(set1.contains (generalization5)) ) ;
                   
                  // bind subClass: UMLClass
                  fujaba__IterGeneralization5ElementsSubClass = generalization5.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization5ElementsSubClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization5ElementsSubClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                         
                        // check To-Many-Link 'stereotypes' between subClass and uMLStereotype4
                        fujaba__IterSubClassStereotypesUMLStereotype4 = subClass.iteratorOfStereotypes () ;
                        while ( fujaba__IterSubClassStereotypesUMLStereotype4.hasNext () )
                        {
                           uMLStereotype4 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterSubClassStereotypesUMLStereotype4.next () ;
                            
                           JavaSDM.ensure ( !((JavaSDM.stringCompare (uMLStereotype4.getText (), "interface") == 0)) ) ;
                        } // while
                         
                        // check To-Many-Link 'annotations' between subClass and methodDecleration6
                        fujaba__IterSubClassAnnotationsMethodDecleration6 = subClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterSubClassAnnotationsMethodDecleration6.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterSubClassAnnotationsMethodDecleration6.next () ;
                            
                           if ( fujaba__TmpObject instanceof MethodDeclerationAnnotation )
                           {
                              methodDecleration6 = (MethodDeclerationAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(methodDecleration6.hasInElements ("declaring", subClass)) ) ;
                           }
                        } // while
                         
                        // linkSearchToSetTop
                        set1 = new de.upb.tools.fca.FHashSet ( ) ;
                        fujaba__IterSet1 = superClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterSet1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterSet1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiLevelGeneralizationAnnotation ) ;
                              fujaba__TmpObjectMultiLevelGeneralizationAnnotation = (MultiLevelGeneralizationAnnotation) fujaba__TmpObject ;
                               
                              set1.remove (generalization5);
                              //  check link :) 'elements' between set1 and subClass
                              JavaSDM.ensure ( fujaba__TmpObjectMultiLevelGeneralizationAnnotation.hasInElements (subClass) ) ;
                               
                              set1.add (fujaba__TmpObjectMultiLevelGeneralizationAnnotation);
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        } // while
                        // constraint
                        JavaSDM.ensure ( set1.size() == 0 ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object subClass is really bound
                              JavaSDM.ensure ( subClass != null ) ;
                               
                              // check object superClass is really bound
                              JavaSDM.ensure ( superClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                               
                              // bind implementationVariant: ImplementationVariantAnnotation
                              fujaba__IterSubClassAnnotationsImplementationVariant = subClass.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterSubClassAnnotationsImplementationVariant.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterSubClassAnnotationsImplementationVariant.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ImplementationVariantAnnotation ) ;
                                    implementationVariant = (ImplementationVariantAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between implementationVariant and subClass
                                    JavaSDM.ensure ( implementationVariant.hasInElements ("variant", subClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between implementationVariant and superClass
                                    JavaSDM.ensure ( implementationVariant.hasInElements ("implements", superClass) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object subClass is really bound
                                 JavaSDM.ensure ( subClass != null ) ;
                                  
                                 // check object superClass is really bound
                                 JavaSDM.ensure ( superClass != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                                  
                                 // create object
                                 implementationVariant = new ImplementationVariantAnnotation ( ) ;
                                  
                                 // create link
                                 implementationVariant.addToElements ("variant", subClass);
                                  
                                 // create link
                                 implementationVariant.addToElements ("implements", superClass);
                                  
                                 // create link
                                 implementationVariant.addToBoundObjects ("subClass", subClass);
                                  
                                 // create link
                                 implementationVariant.addToBoundObjects ("superClass", superClass);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object generalization5 is really bound
                                 JavaSDM.ensure ( generalization5 != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( (set1 == null) || !(set1.contains (generalization5)) ) ;
                                  
                                 // check object implementationVariant is really bound
                                 JavaSDM.ensure ( implementationVariant != null ) ;
                                  
                                 // create link
                                 implementationVariant.addToAntecedentAnnos (generalization5);
                                  
                                 fujaba__IterSet1 = set1.iterator () ;
                                 while ( fujaba__IterSet1.hasNext () )
                                 {
                                    fujaba__TmpObjectMultiLevelGeneralizationAnnotation = (MultiLevelGeneralizationAnnotation) fujaba__IterSet1.next () ;
                                    //  create set link
                                    implementationVariant.addToAntecedentAnnos (fujaba__TmpObjectMultiLevelGeneralizationAnnotation);
                                    fujaba__Success = true ;
                                 } // while
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (implementationVariant) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object implementationVariant is really bound
            JavaSDM.ensure ( implementationVariant != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("implements", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization8 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // check isomorphic binding
            JavaSDM.ensure ( (set1 == null) || !(set1.contains (generalization8)) ) ;
             
            // bind subClass: UMLClass
            fujaba__IterGeneralization8ElementsSubClass = generalization8.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization8ElementsSubClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization8ElementsSubClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind superClass: UMLClass
                  fujaba__IterGeneralization8ElementsSuperClass = generalization8.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization8ElementsSuperClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization8ElementsSuperClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                         
                        // check To-Many-Link 'stereotypes' between subClass and uMLStereotype7
                        fujaba__IterSubClassStereotypesUMLStereotype7 = subClass.iteratorOfStereotypes () ;
                        while ( fujaba__IterSubClassStereotypesUMLStereotype7.hasNext () )
                        {
                           uMLStereotype7 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterSubClassStereotypesUMLStereotype7.next () ;
                            
                           JavaSDM.ensure ( !((JavaSDM.stringCompare (uMLStereotype7.getText (), "interface") == 0)) ) ;
                        } // while
                         
                        // check To-Many-Link 'annotations' between subClass and methodDecleration9
                        fujaba__IterSubClassAnnotationsMethodDecleration9 = subClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterSubClassAnnotationsMethodDecleration9.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterSubClassAnnotationsMethodDecleration9.next () ;
                            
                           if ( fujaba__TmpObject instanceof MethodDeclerationAnnotation )
                           {
                              methodDecleration9 = (MethodDeclerationAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(methodDecleration9.hasInElements ("declaring", subClass)) ) ;
                           }
                        } // while
                         
                        // linkSearchToSetTop
                        set1 = new de.upb.tools.fca.FHashSet ( ) ;
                        fujaba__IterSet1 = subClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterSet1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterSet1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiLevelGeneralizationAnnotation ) ;
                              fujaba__TmpObjectMultiLevelGeneralizationAnnotation = (MultiLevelGeneralizationAnnotation) fujaba__TmpObject ;
                               
                              set1.remove (generalization8);
                              //  check link :) 'elements' between set1 and superClass
                              JavaSDM.ensure ( fujaba__TmpObjectMultiLevelGeneralizationAnnotation.hasInElements (superClass) ) ;
                               
                              set1.add (fujaba__TmpObjectMultiLevelGeneralizationAnnotation);
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        } // while
                        // constraint
                        JavaSDM.ensure ( set1.size() == 0 ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object subClass is really bound
                              JavaSDM.ensure ( subClass != null ) ;
                               
                              // check object superClass is really bound
                              JavaSDM.ensure ( superClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                               
                              // bind implementationVariant: ImplementationVariantAnnotation
                              fujaba__IterSubClassAnnotationsImplementationVariant = subClass.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterSubClassAnnotationsImplementationVariant.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterSubClassAnnotationsImplementationVariant.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ImplementationVariantAnnotation ) ;
                                    implementationVariant = (ImplementationVariantAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between implementationVariant and subClass
                                    JavaSDM.ensure ( implementationVariant.hasInElements ("variant", subClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between implementationVariant and superClass
                                    JavaSDM.ensure ( implementationVariant.hasInElements ("implements", superClass) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object subClass is really bound
                                 JavaSDM.ensure ( subClass != null ) ;
                                  
                                 // check object superClass is really bound
                                 JavaSDM.ensure ( superClass != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                                  
                                 // create object
                                 implementationVariant = new ImplementationVariantAnnotation ( ) ;
                                  
                                 // create link
                                 implementationVariant.addToElements ("variant", subClass);
                                  
                                 // create link
                                 implementationVariant.addToElements ("implements", superClass);
                                  
                                 // create link
                                 implementationVariant.addToBoundObjects ("subClass", subClass);
                                  
                                 // create link
                                 implementationVariant.addToBoundObjects ("superClass", superClass);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object generalization8 is really bound
                                 JavaSDM.ensure ( generalization8 != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( (set1 == null) || !(set1.contains (generalization8)) ) ;
                                  
                                 // check object implementationVariant is really bound
                                 JavaSDM.ensure ( implementationVariant != null ) ;
                                  
                                 // create link
                                 implementationVariant.addToAntecedentAnnos (generalization8);
                                  
                                 fujaba__IterSet1 = set1.iterator () ;
                                 while ( fujaba__IterSet1.hasNext () )
                                 {
                                    fujaba__TmpObjectMultiLevelGeneralizationAnnotation = (MultiLevelGeneralizationAnnotation) fujaba__IterSet1.next () ;
                                    //  create set link
                                    implementationVariant.addToAntecedentAnnos (fujaba__TmpObjectMultiLevelGeneralizationAnnotation);
                                    fujaba__Success = true ;
                                 } // while
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (implementationVariant) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object implementationVariant is really bound
            JavaSDM.ensure ( implementationVariant != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (implementationVariant) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("variant", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("implements", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiLevelGeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MethodDeclerationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterGeneralization10ElementsSubClass = null ;
      Iterator fujaba__IterGeneralization8ElementsSubClass = null ;
      Iterator fujaba__IterSuperClassAnnotationsGeneralization10 = null ;
      GeneralizationAnnotation generalization10 = null ;
      GeneralizationAnnotation generalization8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass subClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass superClass = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (subClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (superClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization8 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind subClass: UMLClass
            fujaba__IterGeneralization8ElementsSubClass = generalization8.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization8ElementsSubClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization8ElementsSubClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (subClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (subClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (superClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("MethodDecleration") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (subClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization10: GeneralizationAnnotation
            fujaba__IterSuperClassAnnotationsGeneralization10 = superClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSuperClassAnnotationsGeneralization10.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSuperClassAnnotationsGeneralization10.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization10 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization10 and superClass
                  JavaSDM.ensure ( generalization10.hasInElements ("superClass", superClass) ) ;
                   
                  // bind subClass: UMLClass
                  fujaba__IterGeneralization10ElementsSubClass = generalization10.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization10ElementsSubClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization10ElementsSubClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                         
                        {
                           //  for each flow
                           set.add (subClass);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization10 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind subClass: UMLClass
            fujaba__IterGeneralization10ElementsSubClass = generalization10.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization10ElementsSubClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization10ElementsSubClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (subClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
