package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class IteratorEngine
extends GFRNEngine
{
   private  IteratorEngine()
   {
   }

   private static IteratorEngine theIteratorEngine;

   public static IteratorEngine get()
   {
      if (theIteratorEngine == null)
      {
         theIteratorEngine = new IteratorEngine ();
      }
      return theIteratorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod1 = null ;
      CreateMethodAnnotation createMethod5 = null ;
      CreateMethodAnnotation createMethod9 = null ;
      Iterator fujaba__IterAggregateClassAnnotationsIterator = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr2 = null ;
      Iterator fujaba__IterAggregateClassMethodsCreateIterator = null ;
      Iterator fujaba__IterCreateIteratorAnnotationsCreateMethod1 = null ;
      Iterator fujaba__IterCreateMethod1ElementsIteratorClass = null ;
      Iterator fujaba__IterCreateMethod5ElementsCreateIterator = null ;
      Iterator fujaba__IterIteratorClassAnnotationsCreateMethod5 = null ;
      Iterator fujaba__IterIteratorClassAnnotationsCreateMethod9 = null ;
      Iterator fujaba__IterIteratorClassAnnotationsIterator = null ;
      Iterator fujaba__IterIteratorClassMethodsUMLMethod7 = null ;
      Iterator fujaba__IterMultiReference12ElementsReferencedClass = null ;
      Iterator fujaba__IterMultiReference12ElementsUMLAttr10 = null ;
      Iterator fujaba__IterMultiReference4ElementsReferencedClass = null ;
      Iterator fujaba__IterMultiReference8ElementsUMLAttr6 = null ;
      Iterator fujaba__IterReferencedClassAnnotationsMultiReference8 = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod11 = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod3 = null ;
      Iterator fujaba__IterUMLAttr2AnnotationsMultiReference4 = null ;
      IteratorAnnotation iterator = null ;
      MultiReferenceAnnotation multiReference12 = null ;
      MultiReferenceAnnotation multiReference4 = null ;
      MultiReferenceAnnotation multiReference8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr10 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr2 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr6 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass aggregateClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass iteratorClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencedClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod createIterator = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod11 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod3 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("aggregate", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            aggregateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr2: UMLAttr
            fujaba__IterAggregateClassAttrsUMLAttr2 = aggregateClass.iteratorOfAttrs () ;
            while ( fujaba__IterAggregateClassAttrsUMLAttr2.hasNext () )
            {
               try
               {
                  uMLAttr2 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr2.next () ;
                   
                  // bind createIterator: UMLMethod
                  fujaba__IterAggregateClassMethodsCreateIterator = aggregateClass.iteratorOfMethods () ;
                  while ( fujaba__IterAggregateClassMethodsCreateIterator.hasNext () )
                  {
                     try
                     {
                        createIterator = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAggregateClassMethodsCreateIterator.next () ;
                         
                        // bind multiReference4: MultiReferenceAnnotation
                        fujaba__IterUMLAttr2AnnotationsMultiReference4 = uMLAttr2.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr2AnnotationsMultiReference4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLAttr2AnnotationsMultiReference4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference4 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference4 and uMLAttr2
                              JavaSDM.ensure ( multiReference4.hasInElements ("field", uMLAttr2) ) ;
                               
                              // bind createMethod1: CreateMethodAnnotation
                              fujaba__IterCreateIteratorAnnotationsCreateMethod1 = createIterator.iteratorOfAnnotations () ;
                              while ( fujaba__IterCreateIteratorAnnotationsCreateMethod1.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateIteratorAnnotationsCreateMethod1.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod1 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod1 and createIterator
                                    JavaSDM.ensure ( createMethod1.hasInElements ("method", createIterator) ) ;
                                     
                                    // bind referencedClass: UMLClass
                                    fujaba__IterMultiReference4ElementsReferencedClass = multiReference4.iteratorOfElements ("references") ;
                                    while ( fujaba__IterMultiReference4ElementsReferencedClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMultiReference4ElementsReferencedClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) ) ;
                                           
                                          // bind iteratorClass: UMLClass
                                          fujaba__IterCreateMethod1ElementsIteratorClass = createMethod1.iteratorOfElements ("creates") ;
                                          while ( fujaba__IterCreateMethod1ElementsIteratorClass.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCreateMethod1ElementsIteratorClass.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                iteratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) && !(referencedClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind uMLMethod3: UMLMethod
                                                fujaba__IterReferencedClassRevResultTypeUMLMethod3 = referencedClass.iteratorOfRevResultType () ;
                                                while ( fujaba__IterReferencedClassRevResultTypeUMLMethod3.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLMethod3 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod3.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(createIterator.equals (uMLMethod3)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between uMLMethod3 and iteratorClass
                                                      JavaSDM.ensure ( (uMLMethod3.getParent () != null) && uMLMethod3.getParent ().equals (iteratorClass) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object aggregateClass is really bound
                                                            JavaSDM.ensure ( aggregateClass != null ) ;
                                                             
                                                            // check object iteratorClass is really bound
                                                            JavaSDM.ensure ( iteratorClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                             
                                                            // bind iterator: IteratorAnnotation
                                                            fujaba__IterAggregateClassAnnotationsIterator = aggregateClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAggregateClassAnnotationsIterator.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAggregateClassAnnotationsIterator.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                                  iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between iterator and aggregateClass
                                                                  JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between iterator and iteratorClass
                                                                  JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object aggregateClass is really bound
                                                               JavaSDM.ensure ( aggregateClass != null ) ;
                                                                
                                                               // check object iteratorClass is really bound
                                                               JavaSDM.ensure ( iteratorClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                                
                                                               // check object createIterator is really bound
                                                               JavaSDM.ensure ( createIterator != null ) ;
                                                                
                                                               // check object referencedClass is really bound
                                                               JavaSDM.ensure ( referencedClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                                
                                                               // create object
                                                               iterator = new IteratorAnnotation ( ) ;
                                                                
                                                               // create link
                                                               iterator.addToElements ("aggregate", aggregateClass);
                                                                
                                                               // create link
                                                               iterator.addToElements ("iterator", iteratorClass);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("createIterator", createIterator);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object createMethod1 is really bound
                                                               JavaSDM.ensure ( createMethod1 != null ) ;
                                                                
                                                               // check object multiReference4 is really bound
                                                               JavaSDM.ensure ( multiReference4 != null ) ;
                                                                
                                                               // check object iterator is really bound
                                                               JavaSDM.ensure ( iterator != null ) ;
                                                                
                                                               // create link
                                                               iterator.addToAntecedentAnnos (createMethod1);
                                                                
                                                               // create link
                                                               iterator.addToAntecedentAnnos (multiReference4);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (iterator) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("aggregate", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("iterator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            iteratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod7: UMLMethod
            fujaba__IterIteratorClassMethodsUMLMethod7 = iteratorClass.iteratorOfMethods () ;
            while ( fujaba__IterIteratorClassMethodsUMLMethod7.hasNext () )
            {
               try
               {
                  uMLMethod7 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterIteratorClassMethodsUMLMethod7.next () ;
                   
                  // bind referencedClass: UMLClass
                  fujaba__TmpObject = uMLMethod7.getResultType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(iteratorClass.equals (referencedClass)) ) ;
                   
                  // bind createMethod5: CreateMethodAnnotation
                  fujaba__IterIteratorClassAnnotationsCreateMethod5 = iteratorClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterIteratorClassAnnotationsCreateMethod5.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsCreateMethod5.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod5 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod5 and iteratorClass
                        JavaSDM.ensure ( createMethod5.hasInElements ("creates", iteratorClass) ) ;
                         
                        // bind multiReference8: MultiReferenceAnnotation
                        fujaba__IterReferencedClassAnnotationsMultiReference8 = referencedClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencedClassAnnotationsMultiReference8.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencedClassAnnotationsMultiReference8.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference8 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference8 and referencedClass
                              JavaSDM.ensure ( multiReference8.hasInElements ("references", referencedClass) ) ;
                               
                              // bind createIterator: UMLMethod
                              fujaba__IterCreateMethod5ElementsCreateIterator = createMethod5.iteratorOfElements ("method") ;
                              while ( fujaba__IterCreateMethod5ElementsCreateIterator.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod5ElementsCreateIterator.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    createIterator = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod7.equals (createIterator)) ) ;
                                     
                                    // bind aggregateClass: UMLClass
                                    aggregateClass = createIterator.getParent () ;
                                    JavaSDM.ensure ( aggregateClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(iteratorClass.equals (aggregateClass)) && !(referencedClass.equals (aggregateClass)) ) ;
                                     
                                    // bind uMLAttr6: UMLAttr
                                    fujaba__IterMultiReference8ElementsUMLAttr6 = multiReference8.iteratorOfElements ("field") ;
                                    while ( fujaba__IterMultiReference8ElementsUMLAttr6.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMultiReference8ElementsUMLAttr6.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                          uMLAttr6 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                           
                                          // check To-One-Link 'parent' between uMLAttr6 and aggregateClass
                                          JavaSDM.ensure ( (uMLAttr6.getParent () != null) && uMLAttr6.getParent ().equals (aggregateClass) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object aggregateClass is really bound
                                                JavaSDM.ensure ( aggregateClass != null ) ;
                                                 
                                                // check object iteratorClass is really bound
                                                JavaSDM.ensure ( iteratorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind iterator: IteratorAnnotation
                                                fujaba__IterIteratorClassAnnotationsIterator = iteratorClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterIteratorClassAnnotationsIterator.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsIterator.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                      iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between iterator and iteratorClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between iterator and aggregateClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object aggregateClass is really bound
                                                   JavaSDM.ensure ( aggregateClass != null ) ;
                                                    
                                                   // check object iteratorClass is really bound
                                                   JavaSDM.ensure ( iteratorClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                    
                                                   // check object createIterator is really bound
                                                   JavaSDM.ensure ( createIterator != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                    
                                                   // create object
                                                   iterator = new IteratorAnnotation ( ) ;
                                                    
                                                   // create link
                                                   iterator.addToElements ("aggregate", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToElements ("iterator", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("createIterator", createIterator);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object createMethod5 is really bound
                                                   JavaSDM.ensure ( createMethod5 != null ) ;
                                                    
                                                   // check object multiReference8 is really bound
                                                   JavaSDM.ensure ( multiReference8 != null ) ;
                                                    
                                                   // check object iterator is really bound
                                                   JavaSDM.ensure ( iterator != null ) ;
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (createMethod5);
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (multiReference8);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (iterator) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("iterator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference12 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            fujaba__IterMultiReference12ElementsReferencedClass = multiReference12.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference12ElementsReferencedClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference12ElementsReferencedClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLAttr10: UMLAttr
                  fujaba__IterMultiReference12ElementsUMLAttr10 = multiReference12.iteratorOfElements ("field") ;
                  while ( fujaba__IterMultiReference12ElementsUMLAttr10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference12ElementsUMLAttr10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr10 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind aggregateClass: UMLClass
                        aggregateClass = uMLAttr10.getParent () ;
                        JavaSDM.ensure ( aggregateClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(referencedClass.equals (aggregateClass)) ) ;
                         
                        // bind uMLMethod11: UMLMethod
                        fujaba__IterReferencedClassRevResultTypeUMLMethod11 = referencedClass.iteratorOfRevResultType () ;
                        while ( fujaba__IterReferencedClassRevResultTypeUMLMethod11.hasNext () )
                        {
                           try
                           {
                              uMLMethod11 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod11.next () ;
                               
                              // bind iteratorClass: UMLClass
                              iteratorClass = uMLMethod11.getParent () ;
                              JavaSDM.ensure ( iteratorClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) && !(referencedClass.equals (iteratorClass)) ) ;
                               
                              // bind createIterator: UMLMethod
                              fujaba__IterAggregateClassMethodsCreateIterator = aggregateClass.iteratorOfMethods () ;
                              while ( fujaba__IterAggregateClassMethodsCreateIterator.hasNext () )
                              {
                                 try
                                 {
                                    createIterator = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAggregateClassMethodsCreateIterator.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod11.equals (createIterator)) ) ;
                                     
                                    // bind createMethod9: CreateMethodAnnotation
                                    fujaba__IterIteratorClassAnnotationsCreateMethod9 = iteratorClass.iteratorOfAnnotations () ;
                                    while ( fujaba__IterIteratorClassAnnotationsCreateMethod9.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsCreateMethod9.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                          createMethod9 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between createMethod9 and iteratorClass
                                          JavaSDM.ensure ( createMethod9.hasInElements ("creates", iteratorClass) ) ;
                                           
                                          // check To-Many-Link 'elements' between createMethod9 and createIterator
                                          JavaSDM.ensure ( createMethod9.hasInElements ("method", createIterator) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object aggregateClass is really bound
                                                JavaSDM.ensure ( aggregateClass != null ) ;
                                                 
                                                // check object iteratorClass is really bound
                                                JavaSDM.ensure ( iteratorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind iterator: IteratorAnnotation
                                                fujaba__IterIteratorClassAnnotationsIterator = iteratorClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterIteratorClassAnnotationsIterator.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsIterator.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                      iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between iterator and iteratorClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between iterator and aggregateClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object aggregateClass is really bound
                                                   JavaSDM.ensure ( aggregateClass != null ) ;
                                                    
                                                   // check object iteratorClass is really bound
                                                   JavaSDM.ensure ( iteratorClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                    
                                                   // check object createIterator is really bound
                                                   JavaSDM.ensure ( createIterator != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                    
                                                   // create object
                                                   iterator = new IteratorAnnotation ( ) ;
                                                    
                                                   // create link
                                                   iterator.addToElements ("aggregate", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToElements ("iterator", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("createIterator", createIterator);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object createMethod9 is really bound
                                                   JavaSDM.ensure ( createMethod9 != null ) ;
                                                    
                                                   // check object multiReference12 is really bound
                                                   JavaSDM.ensure ( multiReference12 != null ) ;
                                                    
                                                   // check object iterator is really bound
                                                   JavaSDM.ensure ( iterator != null ) ;
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (createMethod9);
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (multiReference12);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (iterator) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (iterator) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("aggregate", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("iterator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr13 = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr17 = null ;
      Iterator fujaba__IterIteratorClassMethodsUMLMethod18 = null ;
      Iterator fujaba__IterMultiReference14ElementsReferencedClass = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod15 = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod16 = null ;
      Iterator fujaba__IterUMLAttr13AnnotationsMultiReference14 = null ;
      MultiReferenceAnnotation multiReference14 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr13 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr17 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass aggregateClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass iteratorClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencedClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod15 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod16 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod18 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("CreateMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            aggregateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr13: UMLAttr
            fujaba__IterAggregateClassAttrsUMLAttr13 = aggregateClass.iteratorOfAttrs () ;
            while ( fujaba__IterAggregateClassAttrsUMLAttr13.hasNext () )
            {
               try
               {
                  uMLAttr13 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr13.next () ;
                   
                  // bind multiReference14: MultiReferenceAnnotation
                  fujaba__IterUMLAttr13AnnotationsMultiReference14 = uMLAttr13.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr13AnnotationsMultiReference14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr13AnnotationsMultiReference14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference14 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference14 and uMLAttr13
                        JavaSDM.ensure ( multiReference14.hasInElements ("field", uMLAttr13) ) ;
                         
                        // bind referencedClass: UMLClass
                        fujaba__IterMultiReference14ElementsReferencedClass = multiReference14.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference14ElementsReferencedClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference14ElementsReferencedClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) ) ;
                               
                              // bind uMLMethod15: UMLMethod
                              fujaba__IterReferencedClassRevResultTypeUMLMethod15 = referencedClass.iteratorOfRevResultType () ;
                              while ( fujaba__IterReferencedClassRevResultTypeUMLMethod15.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod15 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod15.next () ;
                                     
                                    // bind iteratorClass: UMLClass
                                    iteratorClass = uMLMethod15.getParent () ;
                                    JavaSDM.ensure ( iteratorClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) && !(referencedClass.equals (iteratorClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (iteratorClass);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            iteratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (iteratorClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference14 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            fujaba__IterMultiReference14ElementsReferencedClass = multiReference14.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference14ElementsReferencedClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference14ElementsReferencedClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod16: UMLMethod
                  fujaba__IterReferencedClassRevResultTypeUMLMethod16 = referencedClass.iteratorOfRevResultType () ;
                  while ( fujaba__IterReferencedClassRevResultTypeUMLMethod16.hasNext () )
                  {
                     try
                     {
                        uMLMethod16 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod16.next () ;
                         
                        // bind iteratorClass: UMLClass
                        iteratorClass = uMLMethod16.getParent () ;
                        JavaSDM.ensure ( iteratorClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(referencedClass.equals (iteratorClass)) ) ;
                         
                        {
                           //  for each flow
                           set.add (iteratorClass);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("MultiReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            aggregateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr17: UMLAttr
            fujaba__IterAggregateClassAttrsUMLAttr17 = aggregateClass.iteratorOfAttrs () ;
            while ( fujaba__IterAggregateClassAttrsUMLAttr17.hasNext () )
            {
               try
               {
                  uMLAttr17 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr17.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr17);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            iteratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod18: UMLMethod
            fujaba__IterIteratorClassMethodsUMLMethod18 = iteratorClass.iteratorOfMethods () ;
            while ( fujaba__IterIteratorClassMethodsUMLMethod18.hasNext () )
            {
               try
               {
                  uMLMethod18 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterIteratorClassMethodsUMLMethod18.next () ;
                   
                  // bind referencedClass: UMLClass
                  fujaba__TmpObject = uMLMethod18.getResultType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(iteratorClass.equals (referencedClass)) ) ;
                   
                  {
                     //  for each flow
                     set.add (referencedClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
