package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLType;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.AssignmentNode;
import de.upb.javaast.methodast.RootBlockNode;

public class SetMethodEngine
extends GFRNEngine
{
   private  SetMethodEngine()
   {
   }

   private static SetMethodEngine theSetMethodEngine;

   public static SetMethodEngine get()
   {
      if (theSetMethodEngine == null)
      {
         theSetMethodEngine = new SetMethodEngine ();
      }
      return theSetMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterLeftExpressionToAttrVariable = null ;
      ASTPathVisitor fujaba__IterRootBlockNode4ToAssignmentNode3 = null ;
      ASTPathVisitor fujaba__IterRootBlockNode8ToAssignmentNode7 = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode3 = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode7 = null ;
      Iterator fujaba__IterAttrTypeRevParamTypeParam = null ;
      Iterator fujaba__IterAttributeAnnotationsSetMethod = null ;
      Iterator fujaba__IterClazzAttrsAttribute = null ;
      Iterator fujaba__IterMethodAnnotationsSetMethod = null ;
      Iterator fujaba__IterMethodParamParam = null ;
      de.upb.javaast.methodast.IdentifierNode attrVariable = null ;
      de.upb.javaast.methodast.IdentifierNode paramVariable = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode leftExpression = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode rightExpression = null ;
      de.upb.javaast.methodast.RootBlockNode rootBlockNode4 = null ;
      de.upb.javaast.methodast.RootBlockNode rootBlockNode8 = null ;
      SetMethodAnnotation setMethod = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attribute = null ;
      de.uni_paderborn.fujaba.uml.UMLClass clazz = null ;
      de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef1 = null ;
      de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef2 = null ;
      de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef5 = null ;
      de.upb.javaast.methodast.references.UMLDeclarationToIdentifierNodeRef uMLDeclarationToIdentifierNodeRef6 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod method = null ;
      de.uni_paderborn.fujaba.uml.UMLParam param = null ;
      de.uni_paderborn.fujaba.uml.UMLType attrType = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attribute = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind attrType: UMLType
            attrType = attribute.getAttrType () ;
            JavaSDM.ensure ( attrType != null ) ;
             
            // bind clazz: UMLClass
            clazz = attribute.getParent () ;
            JavaSDM.ensure ( clazz != null ) ;
             
            // bind param: UMLParam
            fujaba__IterAttrTypeRevParamTypeParam = attrType.iteratorOfRevParamType () ;
            while ( fujaba__IterAttrTypeRevParamTypeParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterAttrTypeRevParamTypeParam.next () ;
                   
                  // bind method: UMLMethod
                  method = param.getRevParam () ;
                  JavaSDM.ensure ( method != null ) ;
                   
                  // check To-One-Link 'parent' between method and clazz
                  JavaSDM.ensure ( (method.getParent () != null) && method.getParent ().equals (clazz) ) ;
                   
                  // bind rootBlockNode4: RootBlockNode
                  fujaba__TmpObject = method.getASTRootNode () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
                  rootBlockNode4 = (de.upb.javaast.methodast.RootBlockNode) fujaba__TmpObject ;
                   
                  // Path search between RootBlockNode and AssignmentNode
                  // Bind assignmentNode3 : AssignmentNode
                  fujaba__IterRootBlockNode4ToAssignmentNode3 = new ASTPathVisitor (rootBlockNode4, AssignmentNode.class ) ;
                  while ( fujaba__IterRootBlockNode4ToAssignmentNode3.hasNext () )
                  {
                     try
                     {
                        assignmentNode3 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootBlockNode4ToAssignmentNode3.next () ;
                         
                        // bind rightExpression: PrimaryExpressionNode
                        fujaba__TmpObject = assignmentNode3.getRightExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                        rightExpression = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                         
                        // bind leftExpression: PrimaryExpressionNode
                        fujaba__TmpObject = assignmentNode3.getLeftExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                        leftExpression = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(rightExpression.equals (leftExpression)) ) ;
                         
                        // bind paramVariable: IdentifierNode
                        paramVariable = rightExpression.getIdentifier () ;
                        JavaSDM.ensure ( paramVariable != null ) ;
                         
                        // bind uMLDeclarationToIdentifierNodeRef1: UMLDeclarationToIdentifierNodeRef
                        uMLDeclarationToIdentifierNodeRef1 = paramVariable.getUmlDeclarationRef () ;
                        JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef1 != null ) ;
                         
                        // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef1 and param
                        JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef1.getElement () != null) && uMLDeclarationToIdentifierNodeRef1.getElement ().equals (param) ) ;
                         
                        // Path search between PrimaryExpressionNode and IdentifierNode
                        // Bind attrVariable : IdentifierNode
                        fujaba__IterLeftExpressionToAttrVariable = new ASTPathVisitor (leftExpression, IdentifierNode.class ) ;
                        while ( fujaba__IterLeftExpressionToAttrVariable.hasNext () )
                        {
                           try
                           {
                              attrVariable = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftExpressionToAttrVariable.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(paramVariable.equals (attrVariable)) ) ;
                               
                              // bind uMLDeclarationToIdentifierNodeRef2: UMLDeclarationToIdentifierNodeRef
                              uMLDeclarationToIdentifierNodeRef2 = attrVariable.getUmlDeclarationRef () ;
                              JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef2 != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef1.equals (uMLDeclarationToIdentifierNodeRef2)) ) ;
                               
                              // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef2 and attribute
                              JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef2.getElement () != null) && uMLDeclarationToIdentifierNodeRef2.getElement ().equals (attribute) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object attribute is really bound
                                    JavaSDM.ensure ( attribute != null ) ;
                                     
                                    // check object method is really bound
                                    JavaSDM.ensure ( method != null ) ;
                                     
                                    // bind setMethod: SetMethodAnnotation
                                    fujaba__IterAttributeAnnotationsSetMethod = attribute.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterAttributeAnnotationsSetMethod.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAttributeAnnotationsSetMethod.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                          setMethod = (SetMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between setMethod and attribute
                                          JavaSDM.ensure ( setMethod.hasInElements ("field", attribute) ) ;
                                           
                                          // check To-Many-Link 'elements' between setMethod and method
                                          JavaSDM.ensure ( setMethod.hasInElements ("method", method) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object attribute is really bound
                                       JavaSDM.ensure ( attribute != null ) ;
                                        
                                       // check object method is really bound
                                       JavaSDM.ensure ( method != null ) ;
                                        
                                       // check object attrType is really bound
                                       JavaSDM.ensure ( attrType != null ) ;
                                        
                                       // check object param is really bound
                                       JavaSDM.ensure ( param != null ) ;
                                        
                                       // check object clazz is really bound
                                       JavaSDM.ensure ( clazz != null ) ;
                                        
                                       // check object attrVariable is really bound
                                       JavaSDM.ensure ( attrVariable != null ) ;
                                        
                                       // check object leftExpression is really bound
                                       JavaSDM.ensure ( leftExpression != null ) ;
                                        
                                       // check object rightExpression is really bound
                                       JavaSDM.ensure ( rightExpression != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(leftExpression.equals (rightExpression)) ) ;
                                        
                                       // check object paramVariable is really bound
                                       JavaSDM.ensure ( paramVariable != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(attrVariable.equals (paramVariable)) ) ;
                                        
                                       // create object
                                       setMethod = new SetMethodAnnotation ( ) ;
                                        
                                       // create link
                                       setMethod.addToElements ("field", attribute);
                                        
                                       // create link
                                       setMethod.addToElements ("method", method);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("attribute", attribute);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("attrType", attrType);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("param", param);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("method", method);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("clazz", clazz);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("attrVariable", attrVariable);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("leftExpression", leftExpression);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("rightExpression", rightExpression);
                                        
                                       // create link
                                       setMethod.addToBoundObjects ("paramVariable", paramVariable);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (setMethod) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object setMethod is really bound
            JavaSDM.ensure ( setMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            method = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind rootBlockNode8: RootBlockNode
            fujaba__TmpObject = method.getASTRootNode () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.RootBlockNode ) ;
            rootBlockNode8 = (de.upb.javaast.methodast.RootBlockNode) fujaba__TmpObject ;
             
            // bind clazz: UMLClass
            clazz = method.getParent () ;
            JavaSDM.ensure ( clazz != null ) ;
             
            // bind param: UMLParam
            fujaba__IterMethodParamParam = method.iteratorOfParam () ;
            while ( fujaba__IterMethodParamParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterMethodParamParam.next () ;
                   
                  // bind attrType: UMLType
                  attrType = param.getParamType () ;
                  JavaSDM.ensure ( attrType != null ) ;
                   
                  // bind attribute: UMLAttr
                  fujaba__IterClazzAttrsAttribute = clazz.iteratorOfAttrs () ;
                  while ( fujaba__IterClazzAttrsAttribute.hasNext () )
                  {
                     try
                     {
                        attribute = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterClazzAttrsAttribute.next () ;
                         
                        // check To-One-Link 'attrType' between attribute and attrType
                        JavaSDM.ensure ( (attribute.getAttrType () != null) && attribute.getAttrType ().equals (attrType) ) ;
                         
                        // Path search between RootBlockNode and AssignmentNode
                        // Bind assignmentNode7 : AssignmentNode
                        fujaba__IterRootBlockNode8ToAssignmentNode7 = new ASTPathVisitor (rootBlockNode8, AssignmentNode.class ) ;
                        while ( fujaba__IterRootBlockNode8ToAssignmentNode7.hasNext () )
                        {
                           try
                           {
                              assignmentNode7 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootBlockNode8ToAssignmentNode7.next () ;
                               
                              // bind leftExpression: PrimaryExpressionNode
                              fujaba__TmpObject = assignmentNode7.getLeftExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                              leftExpression = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                               
                              // bind rightExpression: PrimaryExpressionNode
                              fujaba__TmpObject = assignmentNode7.getRightExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                              rightExpression = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(leftExpression.equals (rightExpression)) ) ;
                               
                              // bind paramVariable: IdentifierNode
                              paramVariable = rightExpression.getIdentifier () ;
                              JavaSDM.ensure ( paramVariable != null ) ;
                               
                              // bind uMLDeclarationToIdentifierNodeRef5: UMLDeclarationToIdentifierNodeRef
                              uMLDeclarationToIdentifierNodeRef5 = paramVariable.getUmlDeclarationRef () ;
                              JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef5 != null ) ;
                               
                              // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef5 and param
                              JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef5.getElement () != null) && uMLDeclarationToIdentifierNodeRef5.getElement ().equals (param) ) ;
                               
                              // Path search between PrimaryExpressionNode and IdentifierNode
                              // Bind attrVariable : IdentifierNode
                              fujaba__IterLeftExpressionToAttrVariable = new ASTPathVisitor (leftExpression, IdentifierNode.class ) ;
                              while ( fujaba__IterLeftExpressionToAttrVariable.hasNext () )
                              {
                                 try
                                 {
                                    attrVariable = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftExpressionToAttrVariable.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(paramVariable.equals (attrVariable)) ) ;
                                     
                                    // bind uMLDeclarationToIdentifierNodeRef6: UMLDeclarationToIdentifierNodeRef
                                    uMLDeclarationToIdentifierNodeRef6 = attrVariable.getUmlDeclarationRef () ;
                                    JavaSDM.ensure ( uMLDeclarationToIdentifierNodeRef6 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLDeclarationToIdentifierNodeRef5.equals (uMLDeclarationToIdentifierNodeRef6)) ) ;
                                     
                                    // check To-One-Link 'element' between uMLDeclarationToIdentifierNodeRef6 and attribute
                                    JavaSDM.ensure ( (uMLDeclarationToIdentifierNodeRef6.getElement () != null) && uMLDeclarationToIdentifierNodeRef6.getElement ().equals (attribute) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object attribute is really bound
                                          JavaSDM.ensure ( attribute != null ) ;
                                           
                                          // check object method is really bound
                                          JavaSDM.ensure ( method != null ) ;
                                           
                                          // bind setMethod: SetMethodAnnotation
                                          fujaba__IterMethodAnnotationsSetMethod = method.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterMethodAnnotationsSetMethod.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterMethodAnnotationsSetMethod.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                                                setMethod = (SetMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between setMethod and method
                                                JavaSDM.ensure ( setMethod.hasInElements ("method", method) ) ;
                                                 
                                                // check To-Many-Link 'elements' between setMethod and attribute
                                                JavaSDM.ensure ( setMethod.hasInElements ("field", attribute) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object attribute is really bound
                                             JavaSDM.ensure ( attribute != null ) ;
                                              
                                             // check object method is really bound
                                             JavaSDM.ensure ( method != null ) ;
                                              
                                             // check object attrType is really bound
                                             JavaSDM.ensure ( attrType != null ) ;
                                              
                                             // check object param is really bound
                                             JavaSDM.ensure ( param != null ) ;
                                              
                                             // check object clazz is really bound
                                             JavaSDM.ensure ( clazz != null ) ;
                                              
                                             // check object attrVariable is really bound
                                             JavaSDM.ensure ( attrVariable != null ) ;
                                              
                                             // check object leftExpression is really bound
                                             JavaSDM.ensure ( leftExpression != null ) ;
                                              
                                             // check object rightExpression is really bound
                                             JavaSDM.ensure ( rightExpression != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(leftExpression.equals (rightExpression)) ) ;
                                              
                                             // check object paramVariable is really bound
                                             JavaSDM.ensure ( paramVariable != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(attrVariable.equals (paramVariable)) ) ;
                                              
                                             // create object
                                             setMethod = new SetMethodAnnotation ( ) ;
                                              
                                             // create link
                                             setMethod.addToElements ("field", attribute);
                                              
                                             // create link
                                             setMethod.addToElements ("method", method);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("attribute", attribute);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("attrType", attrType);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("param", param);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("method", method);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("clazz", clazz);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("attrVariable", attrVariable);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("leftExpression", leftExpression);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("rightExpression", rightExpression);
                                              
                                             // create link
                                             setMethod.addToBoundObjects ("paramVariable", paramVariable);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (setMethod) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object setMethod is really bound
            JavaSDM.ensure ( setMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (setMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
