package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class SingleReferenceEngine
extends GFRNEngine
{
   private  SingleReferenceEngine()
   {
   }

   private static SingleReferenceEngine theSingleReferenceEngine;

   public static SingleReferenceEngine get()
   {
      if (theSingleReferenceEngine == null)
      {
         theSingleReferenceEngine = new SingleReferenceEngine ();
      }
      return theSingleReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterReferencingClassAnnotationsSingleReference = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferencingClassMethodsReadOp = null ;
      Iterator fujaba__IterReferencingClassMethodsWriteOp = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation1 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation3 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReadOperation5 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsSingleReference = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation2 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation4 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsWriteOperation6 = null ;
      Iterator fujaba__IterReferredClassRevAttrTypeReferencingField = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReadOperationAnnotation readOperation1 = null ;
      ReadOperationAnnotation readOperation3 = null ;
      ReadOperationAnnotation readOperation5 = null ;
      SingleReferenceAnnotation singleReference = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referredClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod readOp = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod writeOp = null ;
      WriteOperationAnnotation writeOperation2 = null ;
      WriteOperationAnnotation writeOperation4 = null ;
      WriteOperationAnnotation writeOperation6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferredClassRevAttrTypeReferencingField = referredClass.iteratorOfRevAttrType () ;
            while ( fujaba__IterReferredClassRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferredClassRevAttrTypeReferencingField.next () ;
                   
                  // bind referencingClass: UMLClass
                  referencingClass = referencingField.getParent () ;
                  JavaSDM.ensure ( referencingClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
                   
                  // bind readOperation1: ReadOperationAnnotation
                  fujaba__IterReferencingFieldAnnotationsReadOperation1 = referencingField.iteratorOfAnnotations () ;
                  do
                  {
                     try
                     {
                        readOperation1 = null ;
                        if ( fujaba__IterReferencingFieldAnnotationsReadOperation1.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation1.next () ;
                           if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                           {
                              readOperation1 = (ReadOperationAnnotation) fujaba__TmpObject;
                           }
                           else
                           {
                              JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation1.hasNext ()) ) ;
                           }
                        }
                         
                        // check Reverse-Qualified-Link 'elements' between readOperation1 and referencingField
                        JavaSDM.ensure ( (readOperation1 == null) || readOperation1.hasInElements ("field", referencingField) ) ;
                         
                        // bind writeOperation2: WriteOperationAnnotation
                        fujaba__IterReferencingFieldAnnotationsWriteOperation2 = referencingField.iteratorOfAnnotations () ;
                        do
                        {
                           try
                           {
                              writeOperation2 = null ;
                              if ( fujaba__IterReferencingFieldAnnotationsWriteOperation2.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation2.next () ;
                                 if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                 {
                                    writeOperation2 = (WriteOperationAnnotation) fujaba__TmpObject;
                                 }
                                 else
                                 {
                                    JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation2.hasNext ()) ) ;
                                 }
                              }
                               
                              // check Reverse-Qualified-Link 'elements' between writeOperation2 and referencingField
                              JavaSDM.ensure ( (writeOperation2 == null) || writeOperation2.hasInElements ("field", referencingField) ) ;
                               
                              // bind writeOp: UMLMethod
                              fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                              do
                              {
                                 try
                                 {
                                    writeOp = null ;
                                    if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                                    {
                                       writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                        
                                    }
                                     
                                    // check To-Many-Link 'elements' between writeOperation2 and writeOp
                                    JavaSDM.ensure ( ((writeOperation2 == null) || (writeOp == null)) || ((writeOperation2 != null) || (writeOp != null) || writeOperation2.hasInElements ("method", writeOp)) ) ;
                                     
                                    // bind readOp: UMLMethod
                                    fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                                    do
                                    {
                                       try
                                       {
                                          readOp = null ;
                                          if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                                          {
                                             readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                              
                                          }
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( (readOp == null) || ((writeOp == null) || !(writeOp.equals (readOp))) ) ;
                                           
                                          // check To-Many-Link 'elements' between readOperation1 and readOp
                                          JavaSDM.ensure ( ((readOperation1 == null) || (readOp == null)) || ((readOperation1 != null) || (readOp != null) || readOperation1.hasInElements ("method", readOp)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object referencingClass is really bound
                                                JavaSDM.ensure ( referencingClass != null ) ;
                                                 
                                                // check object referencingField is really bound
                                                JavaSDM.ensure ( referencingField != null ) ;
                                                 
                                                // check object referredClass is really bound
                                                JavaSDM.ensure ( referredClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                 
                                                // bind singleReference: SingleReferenceAnnotation
                                                fujaba__IterReferencingFieldAnnotationsSingleReference = referencingField.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReferencingFieldAnnotationsSingleReference.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsSingleReference.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                                                      singleReference = (SingleReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between singleReference and referencingField
                                                      JavaSDM.ensure ( singleReference.hasInElements ("field", referencingField) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between singleReference and referencingClass
                                                      JavaSDM.ensure ( singleReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between singleReference and referredClass
                                                      JavaSDM.ensure ( singleReference.hasInElements ("references", referredClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object referredClass is really bound
                                                   JavaSDM.ensure ( referredClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( (readOp == null) || ((writeOp == null) || !(writeOp.equals (readOp))) ) ;
                                                    
                                                   // create object
                                                   singleReference = new SingleReferenceAnnotation ( ) ;
                                                    
                                                   // create link
                                                   singleReference.addToElements ("referecningClass", referencingClass);
                                                    
                                                   // create link
                                                   singleReference.addToElements ("field", referencingField);
                                                    
                                                   // create link
                                                   singleReference.addToElements ("references", referredClass);
                                                    
                                                   // create link
                                                   singleReference.addToBoundObjects ("referredClass", referredClass);
                                                    
                                                   // create link
                                                   singleReference.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   if ( writeOp != null )
                                                   {
                                                      singleReference.addToBoundObjects ("writeOp", writeOp);
                                                   } // if
                                                    
                                                   // create link
                                                   singleReference.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   if ( readOp != null )
                                                   {
                                                      singleReference.addToBoundObjects ("readOp", readOp);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object singleReference is really bound
                                                   JavaSDM.ensure ( singleReference != null ) ;
                                                    
                                                   // create link
                                                   if ( readOperation1 != null )
                                                   {
                                                      singleReference.addToAntecedentAnnos (readOperation1);
                                                   } // if
                                                    
                                                   // create link
                                                   if ( writeOperation2 != null )
                                                   {
                                                      singleReference.addToAntecedentAnnos (writeOperation2);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (singleReference) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingFieldAnnotationsWriteOperation2.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingFieldAnnotationsReadOperation1.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object singleReference is really bound
            JavaSDM.ensure ( singleReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind referredClass: UMLClass
            fujaba__TmpObject = referencingField.getAttrType () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
             
            // bind referencingClass: UMLClass
            referencingClass = referencingField.getParent () ;
            JavaSDM.ensure ( referencingClass != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(referredClass.equals (referencingClass)) ) ;
             
            // bind readOperation3: ReadOperationAnnotation
            fujaba__IterReferencingFieldAnnotationsReadOperation3 = referencingField.iteratorOfAnnotations () ;
            do
            {
               try
               {
                  readOperation3 = null ;
                  if ( fujaba__IterReferencingFieldAnnotationsReadOperation3.hasNext () )
                  {
                     fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation3.next () ;
                     if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                     {
                        readOperation3 = (ReadOperationAnnotation) fujaba__TmpObject;
                     }
                     else
                     {
                        JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation3.hasNext ()) ) ;
                     }
                  }
                   
                  // check Reverse-Qualified-Link 'elements' between readOperation3 and referencingField
                  JavaSDM.ensure ( (readOperation3 == null) || readOperation3.hasInElements ("field", referencingField) ) ;
                   
                  // bind writeOperation4: WriteOperationAnnotation
                  fujaba__IterReferencingFieldAnnotationsWriteOperation4 = referencingField.iteratorOfAnnotations () ;
                  do
                  {
                     try
                     {
                        writeOperation4 = null ;
                        if ( fujaba__IterReferencingFieldAnnotationsWriteOperation4.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation4.next () ;
                           if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                           {
                              writeOperation4 = (WriteOperationAnnotation) fujaba__TmpObject;
                           }
                           else
                           {
                              JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation4.hasNext ()) ) ;
                           }
                        }
                         
                        // check Reverse-Qualified-Link 'elements' between writeOperation4 and referencingField
                        JavaSDM.ensure ( (writeOperation4 == null) || writeOperation4.hasInElements ("field", referencingField) ) ;
                         
                        // bind writeOp: UMLMethod
                        fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                        do
                        {
                           try
                           {
                              writeOp = null ;
                              if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                              {
                                 writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                                  
                              }
                               
                              // check To-Many-Link 'elements' between writeOperation4 and writeOp
                              JavaSDM.ensure ( ((writeOperation4 == null) || (writeOp == null)) || ((writeOperation4 != null) || (writeOp != null) || writeOperation4.hasInElements ("method", writeOp)) ) ;
                               
                              // bind readOp: UMLMethod
                              fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                              do
                              {
                                 try
                                 {
                                    readOp = null ;
                                    if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                                    {
                                       readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                        
                                    }
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( (readOp == null) || ((writeOp == null) || !(writeOp.equals (readOp))) ) ;
                                     
                                    // check To-Many-Link 'elements' between readOperation3 and readOp
                                    JavaSDM.ensure ( ((readOperation3 == null) || (readOp == null)) || ((readOperation3 != null) || (readOp != null) || readOperation3.hasInElements ("method", readOp)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object referencingClass is really bound
                                          JavaSDM.ensure ( referencingClass != null ) ;
                                           
                                          // check object referencingField is really bound
                                          JavaSDM.ensure ( referencingField != null ) ;
                                           
                                          // check object referredClass is really bound
                                          JavaSDM.ensure ( referredClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                           
                                          // bind singleReference: SingleReferenceAnnotation
                                          fujaba__IterReferencingClassAnnotationsSingleReference = referencingClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterReferencingClassAnnotationsSingleReference.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterReferencingClassAnnotationsSingleReference.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                                                singleReference = (SingleReferenceAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between singleReference and referencingClass
                                                JavaSDM.ensure ( singleReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between singleReference and referencingField
                                                JavaSDM.ensure ( singleReference.hasInElements ("field", referencingField) ) ;
                                                 
                                                // check To-Many-Link 'elements' between singleReference and referredClass
                                                JavaSDM.ensure ( singleReference.hasInElements ("references", referredClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object referencingClass is really bound
                                             JavaSDM.ensure ( referencingClass != null ) ;
                                              
                                             // check object referencingField is really bound
                                             JavaSDM.ensure ( referencingField != null ) ;
                                              
                                             // check object referredClass is really bound
                                             JavaSDM.ensure ( referredClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( (readOp == null) || ((writeOp == null) || !(writeOp.equals (readOp))) ) ;
                                              
                                             // create object
                                             singleReference = new SingleReferenceAnnotation ( ) ;
                                              
                                             // create link
                                             singleReference.addToElements ("referecningClass", referencingClass);
                                              
                                             // create link
                                             singleReference.addToElements ("field", referencingField);
                                              
                                             // create link
                                             singleReference.addToElements ("references", referredClass);
                                              
                                             // create link
                                             singleReference.addToBoundObjects ("referredClass", referredClass);
                                              
                                             // create link
                                             singleReference.addToBoundObjects ("referencingField", referencingField);
                                              
                                             // create link
                                             if ( writeOp != null )
                                             {
                                                singleReference.addToBoundObjects ("writeOp", writeOp);
                                             } // if
                                              
                                             // create link
                                             singleReference.addToBoundObjects ("referencingClass", referencingClass);
                                              
                                             // create link
                                             if ( readOp != null )
                                             {
                                                singleReference.addToBoundObjects ("readOp", readOp);
                                             } // if
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object singleReference is really bound
                                             JavaSDM.ensure ( singleReference != null ) ;
                                              
                                             // create link
                                             if ( readOperation3 != null )
                                             {
                                                singleReference.addToAntecedentAnnos (readOperation3);
                                             } // if
                                              
                                             // create link
                                             if ( writeOperation4 != null )
                                             {
                                                singleReference.addToAntecedentAnnos (writeOperation4);
                                             } // if
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (singleReference) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingFieldAnnotationsWriteOperation4.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
            while ( fujaba__IterReferencingFieldAnnotationsReadOperation3.hasNext () ) ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object singleReference is really bound
            JavaSDM.ensure ( singleReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("referecningClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  // bind referredClass: UMLClass
                  fujaba__TmpObject = referencingField.getAttrType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                   
                  // bind writeOp: UMLMethod
                  fujaba__IterReferencingClassMethodsWriteOp = referencingClass.iteratorOfMethods () ;
                  do
                  {
                     try
                     {
                        writeOp = null ;
                        if ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () )
                        {
                           writeOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsWriteOp.next () ;
                            
                        }
                         
                        // bind readOp: UMLMethod
                        fujaba__IterReferencingClassMethodsReadOp = referencingClass.iteratorOfMethods () ;
                        do
                        {
                           try
                           {
                              readOp = null ;
                              if ( fujaba__IterReferencingClassMethodsReadOp.hasNext () )
                              {
                                 readOp = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsReadOp.next () ;
                                  
                              }
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( (readOp == null) || ((writeOp == null) || !(writeOp.equals (readOp))) ) ;
                               
                              // bind readOperation5: ReadOperationAnnotation
                              fujaba__IterReferencingFieldAnnotationsReadOperation5 = referencingField.iteratorOfAnnotations () ;
                              do
                              {
                                 try
                                 {
                                    readOperation5 = null ;
                                    if ( fujaba__IterReferencingFieldAnnotationsReadOperation5.hasNext () )
                                    {
                                       fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReadOperation5.next () ;
                                       if ( fujaba__TmpObject instanceof ReadOperationAnnotation )
                                       {
                                          readOperation5 = (ReadOperationAnnotation) fujaba__TmpObject;
                                       }
                                       else
                                       {
                                          JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsReadOperation5.hasNext ()) ) ;
                                       }
                                    }
                                     
                                    // check Reverse-Qualified-Link 'elements' between readOperation5 and referencingField
                                    JavaSDM.ensure ( (readOperation5 == null) || readOperation5.hasInElements ("field", referencingField) ) ;
                                     
                                    // check To-Many-Link 'elements' between readOperation5 and readOp
                                    JavaSDM.ensure ( ((readOperation5 == null) || (readOp == null)) || ((readOperation5 != null) || (readOp != null) || readOperation5.hasInElements ("method", readOp)) ) ;
                                     
                                    // bind writeOperation6: WriteOperationAnnotation
                                    fujaba__IterReferencingFieldAnnotationsWriteOperation6 = referencingField.iteratorOfAnnotations () ;
                                    do
                                    {
                                       try
                                       {
                                          writeOperation6 = null ;
                                          if ( fujaba__IterReferencingFieldAnnotationsWriteOperation6.hasNext () )
                                          {
                                             fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsWriteOperation6.next () ;
                                             if ( fujaba__TmpObject instanceof WriteOperationAnnotation )
                                             {
                                                writeOperation6 = (WriteOperationAnnotation) fujaba__TmpObject;
                                             }
                                             else
                                             {
                                                JavaSDM.ensure ( !(fujaba__IterReferencingFieldAnnotationsWriteOperation6.hasNext ()) ) ;
                                             }
                                          }
                                           
                                          // check Reverse-Qualified-Link 'elements' between writeOperation6 and referencingField
                                          JavaSDM.ensure ( (writeOperation6 == null) || writeOperation6.hasInElements ("field", referencingField) ) ;
                                           
                                          // check To-Many-Link 'elements' between writeOperation6 and writeOp
                                          JavaSDM.ensure ( ((writeOperation6 == null) || (writeOp == null)) || ((writeOperation6 != null) || (writeOp != null) || writeOperation6.hasInElements ("method", writeOp)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object referencingClass is really bound
                                                JavaSDM.ensure ( referencingClass != null ) ;
                                                 
                                                // check object referencingField is really bound
                                                JavaSDM.ensure ( referencingField != null ) ;
                                                 
                                                // check object referredClass is really bound
                                                JavaSDM.ensure ( referredClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                 
                                                // bind singleReference: SingleReferenceAnnotation
                                                fujaba__IterReferencingFieldAnnotationsSingleReference = referencingField.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterReferencingFieldAnnotationsSingleReference.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsSingleReference.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                                                      singleReference = (SingleReferenceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between singleReference and referencingField
                                                      JavaSDM.ensure ( singleReference.hasInElements ("field", referencingField) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between singleReference and referencingClass
                                                      JavaSDM.ensure ( singleReference.hasInElements ("referecningClass", referencingClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between singleReference and referredClass
                                                      JavaSDM.ensure ( singleReference.hasInElements ("references", referredClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object referredClass is really bound
                                                   JavaSDM.ensure ( referredClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(referencingClass.equals (referredClass)) ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( (readOp == null) || ((writeOp == null) || !(writeOp.equals (readOp))) ) ;
                                                    
                                                   // create object
                                                   singleReference = new SingleReferenceAnnotation ( ) ;
                                                    
                                                   // create link
                                                   singleReference.addToElements ("referecningClass", referencingClass);
                                                    
                                                   // create link
                                                   singleReference.addToElements ("field", referencingField);
                                                    
                                                   // create link
                                                   singleReference.addToElements ("references", referredClass);
                                                    
                                                   // create link
                                                   singleReference.addToBoundObjects ("referredClass", referredClass);
                                                    
                                                   // create link
                                                   singleReference.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   if ( writeOp != null )
                                                   {
                                                      singleReference.addToBoundObjects ("writeOp", writeOp);
                                                   } // if
                                                    
                                                   // create link
                                                   singleReference.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   if ( readOp != null )
                                                   {
                                                      singleReference.addToBoundObjects ("readOp", readOp);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object singleReference is really bound
                                                   JavaSDM.ensure ( singleReference != null ) ;
                                                    
                                                   // create link
                                                   if ( readOperation5 != null )
                                                   {
                                                      singleReference.addToAntecedentAnnos (readOperation5);
                                                   } // if
                                                    
                                                   // create link
                                                   if ( writeOperation6 != null )
                                                   {
                                                      singleReference.addToAntecedentAnnos (writeOperation6);
                                                   } // if
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (singleReference) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                    while ( fujaba__IterReferencingFieldAnnotationsWriteOperation6.hasNext () ) ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                              while ( fujaba__IterReferencingFieldAnnotationsReadOperation5.hasNext () ) ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                        while ( fujaba__IterReferencingClassMethodsReadOp.hasNext () ) ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
                  while ( fujaba__IterReferencingClassMethodsWriteOp.hasNext () ) ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object singleReference is really bound
            JavaSDM.ensure ( singleReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("referecningClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (singleReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("referecningClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferredClassRevAttrTypeReferencingField = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referredClass = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("ReadOperation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferredClassRevAttrTypeReferencingField = referredClass.iteratorOfRevAttrType () ;
            while ( fujaba__IterReferredClassRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferredClassRevAttrTypeReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("WriteOperation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referencingClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
            while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            referredClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReferredClassRevAttrTypeReferencingField = referredClass.iteratorOfRevAttrType () ;
            while ( fujaba__IterReferredClassRevAttrTypeReferencingField.hasNext () )
            {
               try
               {
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferredClassRevAttrTypeReferencingField.next () ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (referencingField);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
