package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;

public class WriteOperationEngine
extends GFRNEngine
{
   private  WriteOperationEngine()
   {
   }

   private static WriteOperationEngine theWriteOperationEngine;

   public static WriteOperationEngine get()
   {
      if (theWriteOperationEngine == null)
      {
         theWriteOperationEngine = new WriteOperationEngine ();
      }
      return theWriteOperationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      AssignmentAnnotation assignment1 = null ;
      AssignmentAnnotation assignment2 = null ;
      AssignmentAnnotation assignment3 = null ;
      Iterator fujaba__IterAssignment1ElementsAttrib = null ;
      Iterator fujaba__IterAssignment1ElementsWriteMethod = null ;
      Iterator fujaba__IterAssignment2ElementsAttrib = null ;
      Iterator fujaba__IterAssignment3ElementsWriteMethod = null ;
      Iterator fujaba__IterAttribAnnotationsAssignment3 = null ;
      Iterator fujaba__IterAttribAnnotationsWriteOperation = null ;
      Iterator fujaba__IterWriteMethodAnnotationsAssignment2 = null ;
      Iterator fujaba__IterWriteMethodAnnotationsWriteOperation = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attrib = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod writeMethod = null ;
      WriteOperationAnnotation writeOperation = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof AssignmentAnnotation ) ;
             
            // explicit type cast
            assignment1 = (AssignmentAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind writeMethod: UMLMethod
            fujaba__IterAssignment1ElementsWriteMethod = assignment1.iteratorOfElements ("method") ;
            while ( fujaba__IterAssignment1ElementsWriteMethod.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAssignment1ElementsWriteMethod.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  writeMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind attrib: UMLAttr
                  fujaba__IterAssignment1ElementsAttrib = assignment1.iteratorOfElements ("field") ;
                  while ( fujaba__IterAssignment1ElementsAttrib.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssignment1ElementsAttrib.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // constraint
                        JavaSDM.ensure ( writeMethod.getName().matches("(?i)(set|addto)" + attrib.getName()) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object writeMethod is really bound
                              JavaSDM.ensure ( writeMethod != null ) ;
                               
                              // check object attrib is really bound
                              JavaSDM.ensure ( attrib != null ) ;
                               
                              // bind writeOperation: WriteOperationAnnotation
                              fujaba__IterWriteMethodAnnotationsWriteOperation = writeMethod.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterWriteMethodAnnotationsWriteOperation.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterWriteMethodAnnotationsWriteOperation.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof WriteOperationAnnotation ) ;
                                    writeOperation = (WriteOperationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between writeOperation and writeMethod
                                    JavaSDM.ensure ( writeOperation.hasInElements ("method", writeMethod) ) ;
                                     
                                    // check To-Many-Link 'elements' between writeOperation and attrib
                                    JavaSDM.ensure ( writeOperation.hasInElements ("field", attrib) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object writeMethod is really bound
                                 JavaSDM.ensure ( writeMethod != null ) ;
                                  
                                 // check object attrib is really bound
                                 JavaSDM.ensure ( attrib != null ) ;
                                  
                                 // create object
                                 writeOperation = new WriteOperationAnnotation ( ) ;
                                  
                                 // create link
                                 writeOperation.addToElements ("method", writeMethod);
                                  
                                 // create link
                                 writeOperation.addToElements ("field", attrib);
                                  
                                 // create link
                                 writeOperation.addToBoundObjects ("writeMethod", writeMethod);
                                  
                                 // create link
                                 writeOperation.addToBoundObjects ("attrib", attrib);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object assignment1 is really bound
                                 JavaSDM.ensure ( assignment1 != null ) ;
                                  
                                 // check object writeOperation is really bound
                                 JavaSDM.ensure ( writeOperation != null ) ;
                                  
                                 // create link
                                 writeOperation.addToAntecedentAnnos (assignment1);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (writeOperation) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object writeOperation is really bound
            JavaSDM.ensure ( writeOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            writeMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind assignment2: AssignmentAnnotation
            fujaba__IterWriteMethodAnnotationsAssignment2 = writeMethod.iteratorOfAnnotations () ;
            while ( fujaba__IterWriteMethodAnnotationsAssignment2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterWriteMethodAnnotationsAssignment2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentAnnotation ) ;
                  assignment2 = (AssignmentAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assignment2 and writeMethod
                  JavaSDM.ensure ( assignment2.hasInElements ("method", writeMethod) ) ;
                   
                  // bind attrib: UMLAttr
                  fujaba__IterAssignment2ElementsAttrib = assignment2.iteratorOfElements ("field") ;
                  while ( fujaba__IterAssignment2ElementsAttrib.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssignment2ElementsAttrib.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // constraint
                        JavaSDM.ensure ( writeMethod.getName().matches("(?i)(set|addto)" + attrib.getName()) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object writeMethod is really bound
                              JavaSDM.ensure ( writeMethod != null ) ;
                               
                              // check object attrib is really bound
                              JavaSDM.ensure ( attrib != null ) ;
                               
                              // bind writeOperation: WriteOperationAnnotation
                              fujaba__IterAttribAnnotationsWriteOperation = attrib.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsWriteOperation.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAttribAnnotationsWriteOperation.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof WriteOperationAnnotation ) ;
                                    writeOperation = (WriteOperationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between writeOperation and attrib
                                    JavaSDM.ensure ( writeOperation.hasInElements ("field", attrib) ) ;
                                     
                                    // check To-Many-Link 'elements' between writeOperation and writeMethod
                                    JavaSDM.ensure ( writeOperation.hasInElements ("method", writeMethod) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object writeMethod is really bound
                                 JavaSDM.ensure ( writeMethod != null ) ;
                                  
                                 // check object attrib is really bound
                                 JavaSDM.ensure ( attrib != null ) ;
                                  
                                 // create object
                                 writeOperation = new WriteOperationAnnotation ( ) ;
                                  
                                 // create link
                                 writeOperation.addToElements ("method", writeMethod);
                                  
                                 // create link
                                 writeOperation.addToElements ("field", attrib);
                                  
                                 // create link
                                 writeOperation.addToBoundObjects ("writeMethod", writeMethod);
                                  
                                 // create link
                                 writeOperation.addToBoundObjects ("attrib", attrib);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object assignment2 is really bound
                                 JavaSDM.ensure ( assignment2 != null ) ;
                                  
                                 // check object writeOperation is really bound
                                 JavaSDM.ensure ( writeOperation != null ) ;
                                  
                                 // create link
                                 writeOperation.addToAntecedentAnnos (assignment2);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (writeOperation) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object writeOperation is really bound
            JavaSDM.ensure ( writeOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind assignment3: AssignmentAnnotation
            fujaba__IterAttribAnnotationsAssignment3 = attrib.iteratorOfAnnotations () ;
            while ( fujaba__IterAttribAnnotationsAssignment3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterAttribAnnotationsAssignment3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentAnnotation ) ;
                  assignment3 = (AssignmentAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between assignment3 and attrib
                  JavaSDM.ensure ( assignment3.hasInElements ("field", attrib) ) ;
                   
                  // bind writeMethod: UMLMethod
                  fujaba__IterAssignment3ElementsWriteMethod = assignment3.iteratorOfElements ("method") ;
                  while ( fujaba__IterAssignment3ElementsWriteMethod.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAssignment3ElementsWriteMethod.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        writeMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // constraint
                        JavaSDM.ensure ( writeMethod.getName().matches("(?i)(set|addto)" + attrib.getName()) ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object writeMethod is really bound
                              JavaSDM.ensure ( writeMethod != null ) ;
                               
                              // check object attrib is really bound
                              JavaSDM.ensure ( attrib != null ) ;
                               
                              // bind writeOperation: WriteOperationAnnotation
                              fujaba__IterAttribAnnotationsWriteOperation = attrib.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsWriteOperation.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAttribAnnotationsWriteOperation.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof WriteOperationAnnotation ) ;
                                    writeOperation = (WriteOperationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between writeOperation and attrib
                                    JavaSDM.ensure ( writeOperation.hasInElements ("field", attrib) ) ;
                                     
                                    // check To-Many-Link 'elements' between writeOperation and writeMethod
                                    JavaSDM.ensure ( writeOperation.hasInElements ("method", writeMethod) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object writeMethod is really bound
                                 JavaSDM.ensure ( writeMethod != null ) ;
                                  
                                 // check object attrib is really bound
                                 JavaSDM.ensure ( attrib != null ) ;
                                  
                                 // create object
                                 writeOperation = new WriteOperationAnnotation ( ) ;
                                  
                                 // create link
                                 writeOperation.addToElements ("method", writeMethod);
                                  
                                 // create link
                                 writeOperation.addToElements ("field", attrib);
                                  
                                 // create link
                                 writeOperation.addToBoundObjects ("writeMethod", writeMethod);
                                  
                                 // create link
                                 writeOperation.addToBoundObjects ("attrib", attrib);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object assignment3 is really bound
                                 JavaSDM.ensure ( assignment3 != null ) ;
                                  
                                 // check object writeOperation is really bound
                                 JavaSDM.ensure ( writeOperation != null ) ;
                                  
                                 // create link
                                 writeOperation.addToAntecedentAnnos (assignment3);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (writeOperation) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object writeOperation is really bound
            JavaSDM.ensure ( writeOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (writeOperation) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AssignmentAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attrib = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod writeMethod = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Assignment") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            writeMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (writeMethod);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (attrib);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
